#ifndef __draw__
#define __draw__

#include <gtk/gtk.h>
#include "struct.h"

GdkPixbuf *initDraw();
void initDrawFont(Level* level);
void setRozmer(Level* level,guint x);
void loadPixmaps(Level* level);
void unrefPixmaps();
void drawWholeMap(GtkWidget *widget,GdkEventExpose *event,gpointer data);
void redrawPlayer(Level* level,guint32 oldX,guint32 oldY);
void redrawBalaban(Level* level,Balaban* balaban,guint32 oldX,guint32 oldY);
void drawMine(Level* level,guint32 x,guint32 y);
void animateShotsX(Level* level,guint32 x,guint32 odY,gint32 doY,gboolean zasah);
void animateShotsY(Level* level,guint32 y,guint32 odX,gint32 doX,gboolean zasah);
void animateVybuch(Level* level,GList* list);
void drawPole(Level* level,guint32 x,guint32 y);
void animateDraka(Level* level,guint32 x,guint32 y,GList* list);
void drawBadMove(Level* level,gint co);
void animateCat(Level* level,guint32 odX,guint32 doX,gint32 y,GList* list);
void loadButtonPixbuf(GdkPixbuf **pixb);
void redrawAllEnter(Level* level);
void animateHod(Level* level,guint32 odX,guint32 odY,guint32 doX,guint32 doY);
GtkWidget* createTableTips(guint32 ktere);
gboolean porovnejCas(GTimeVal* cas);

#endif
