/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */
#include "level2.h"
#include "level_func.h"

#define L1 1
#define L2 2
#define L3 3
#define L4 4
#define L5 5
#define L6 19
#define L7 95
#define L8 14
#define L9 13
#define L10 34
#define L11 60
#define L12 62
#define L13 22
#define L14 70
#define L15 63
#define L16 67
#define L17 23
#define L18 81
#define L19 25
#define L20 100
#define L21 38
#define L22 39
#define L23 18
#define L24 72
#define L25 56
#define L26 58
#define L27 40
#define L28 16
#define L29 71
#define L30 54
#define L31 32
#define L32 42
#define L33 83
#define L34 50
#define L35 21
#define L36 7
#define L37 11
#define L38 27
#define L39 51
#define L40 26
#define L41 36
#define L42 53
#define L43 15
#define L44 80
#define L45 48
#define L46 52
#define L47 85
#define L48 12
#define L49 30
#define L50 28
#define L51 44
#define L52 89
#define L53 91
#define L54 99
#define L55 31
#define L56 64
#define L57 92
#define L58 43
#define L59 90
#define L60 59
#define L61 78
#define L62 45
#define L63 35
#define L64 29
#define L65 94
#define L66 37
#define L67 55
#define L68 57
#define L69 93
#define L70 69
#define L71 76
#define L72 82
#define L73 17
#define L74 10
#define L75 49
#define L76 66
#define L77 74
#define L78 75
#define L79 61
#define L80 79
#define L81 77
#define L82 6
#define L83 65
#define L84 68
#define L85 20
#define L86 8
#define L87 9
#define L88 24
#define L89 97
#define L90 47
#define L91 41
#define L92 84
#define L93 86
#define L94 87
#define L95 88
#define L96 96
#define L97 33
#define L98 73
#define L99 46
#define L100 98

static void getLevel1(Level* level)
{
    gint i;
    level->level=L1;

	level->tip=16777216;
    level->max=15; 
    set_map(&level->map,25,12);
    level->endFunc=COUNT_END;
    
    for(i=0;i<12;i++){
		if(i==5)i++;
        setField(level,i*25,3);
		setField(level,i*25+1,2);
    }
  
    setField(level,25*5+2,46);

    level->balabans=NULL;
    for(i=0;i<12;i++){
		alloc_balaban(24,i,1,&level->balabans);
		alloc_balaban(23,i,2,&level->balabans);
	}
    
	setField(level,5*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,5*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,5*25+14,39);    
    setField(level,6*25+15,38);
         
    set_player(&level->player,22,6,5,5);  
}

static void getLevel2(Level* level)
{
    gint i,j;

    
    level->level=L2;

	level->tip=8388608;
    level->max=10; 
    set_map(&level->map,25,13);
    level->endFunc=COUNT_END;
    
    for(i=0;i<13;i++){
		setField(level,i*25,3);
		for(j=1;j<23;j++){
			if((i+j)%4==0)setField(level,i*25+j,45);
		}
    }
 
    level->balabans=NULL;
    for(i=0;i<13;i++){
		alloc_balaban(24,i,1,&level->balabans);
		alloc_balaban(23,i,2,&level->balabans);
	}
    
	setField(level,6*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,6*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,6*25+14,39);    
    setField(level,6*25+15,38);
         
    set_player(&level->player,22,8,10,10);  
}

static void getLevel3(Level* level)
{
    gint i,j;

    
    level->level=L3;

	level->tip=4194304;
    level->max=5; 
    set_map(&level->map,25,13);
    level->endFunc=COUNT_END;
    
    for(i=0;i<13;i+=2){
		setField(level,i*25,3);
		for(j=2;j<21;j+=2){
			if((3*i+j)%4==0)setField(level,i*25+j,44);
			if((3*i+j)%7==1)setField(level,i*25+j,5);
			if((3*i+j)%11==2)setField(level,i*25+j,3);
		}
    }
 
    level->balabans=NULL;
    for(i=0;i<13;i++){
		alloc_balaban(24,i,1,&level->balabans);
		alloc_balaban(23,i,2,&level->balabans);
		alloc_balaban(22,i,1,&level->balabans);
	}
    
	setField(level,6*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,6*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,6*25+14,39);    
    setField(level,6*25+15,38);
         
    set_player(&level->player,21,9,10,10);  
}

static void getLevel4(Level* level)
{
    gint i;

    
    level->level=L4;

	level->tip=2097152;
    level->max=5; 
    set_map(&level->map,25,13);
    level->endFunc=COUNT_END;
    
    for(i=0;i<13;i+=2){
		setField(level,i*25,3);
    }
 
    level->balabans=NULL;
    for(i=0;i<13;i++){
		alloc_balaban(24,i,4,&level->balabans);
	}
    
	setField(level,6*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,6*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,6*25+14,39);    
    setField(level,6*25+15,38);

	setField(level,10*25+10,5);
	setField(level,8*25+7,5);
	setField(level,2*25+3,5);
         
    set_player(&level->player,10,12,20,5);  
}

static void getLevel5(Level* level)
{
    gint i;

    
    level->level=L5;

	level->tip=1048576;
    level->max=2; 
    set_map(&level->map,25,13);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<13;i+=3){
		alloc_balaban(24,i,3,&level->balabans);
	}
    
	setField(level,6*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,6*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,6*25+14,39);    
    setField(level,6*25+15,38);

    set_player(&level->player,10,4,12,5);  
}

static void getLevel6(Level* level)
{
    gint i;

    
    level->level=L6;

	level->max=7; 
    set_map(&level->map,25,13);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<13;i+=2){
		alloc_balaban(24,i,3,&level->balabans);
	}
    
	setField(level,6*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,6*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,6*25+14,39);    
    setField(level,6*25+15,38);

	setField(level,2*25+3,3);
         
    set_player(&level->player,10,4,6,0);  
}

static void getLevel7(Level* level)
{
    gint i,j;

    
    level->level=L7;

	level->max=12; 
    set_map(&level->map,25,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=19;i<25;i++){
		for(j=14;j<20;j++){
			alloc_balaban(i,j,3,&level->balabans);
		}
	}
    for(i=0;i<20;i++){
		for(j=0;j<17;j++){
			if((i*17+j)%29==0)setField(level,i*25+j,1);
			if((i*17+j)%27==15)setField(level,i*25+j,2);
		}
	}
    setField(level,14*25+14,44);
    set_player(&level->player,13,14,50,50);  
}

static void getLevel8(Level* level)
{
    gint i;

    
    level->level=L8;

	level->max=10; 
    set_map(&level->map,25,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<20;i++){
		alloc_balaban(0,i,0,&level->balabans);
		alloc_balaban(1,i,4,&level->balabans);
		alloc_balaban(2,i,0,&level->balabans);
	}
    for(i=0;i<3;i++){
	    setField(level,i*100+29,44);
		setField(level,i*100+254,44);
		setField(level,i*100+33,44);
		setField(level,i*100+258,44);
	}
    setField(level,10*25+5,5);
    setField(level,10*25+6,3);
    setField(level,10*25+7,5);

	setField(level,11*25+4,5);
    setField(level,12*25+4,3);
    setField(level,13*25+4,5);

	setField(level,15*25+4,5);
    setField(level,16*25+4,3);
    setField(level,17*25+4,5);

    setField(level,18*25+5,5);
    setField(level,18*25+6,3);
    setField(level,18*25+7,5);

	setField(level,9*25+9,44);
	setField(level,10*25+13,44);
	setField(level,10*25+24,3);

    set_player(&level->player,10,6,3,3);  
}

static gboolean level9_end(Level* level)
{
	gint potrebaPocetNaboju=0;
    if(level->map.field[19+14]==1 && level->map.field[19+15]==1 && level->map.field[19+16]==1) potrebaPocetNaboju++;
    if(level->map.field[12*19+14]==1 && level->map.field[12*19+15]==1 && level->map.field[12*19+16]==1) potrebaPocetNaboju++;
    return potrebaPocetNaboju<=COUNT_SHOTS(level);
}

static void getLevel9(Level* level)
{
    gint i;

    
    level->level=L9;

	level->max=20; 
    set_map(&level->map,19,14);
    level->endFunc=level9_end;

    level->balabans=NULL;
    for(i=0;i<5;i++){
		alloc_balaban(i,13,0,&level->balabans);
		alloc_balaban(i,12,4,&level->balabans);
        if(i<3){
			setField(level,19+i+14,1);
			setField(level,12*19+i+14,1);
		}
	}
    for(i=0;i<14;i++){
		if(i<5 || i>7)setField(level,i*19+5,2);
		if(i!=6)setField(level,i*19+13,2);
		if(i!=6)setField(level,i*19+17,2);
	    if(i>4 && i!=11 && i<13){
			setField(level,4*19+i,2);
			setField(level,8*19+i,2);
		}
		if(i>3 && i<7)setField(level,i*19+4,11);
	}

    setField(level,6,5);
    setField(level,7,3);
    setField(level,8,5);
    setField(level,9,5);
    setField(level,10,3);

	setField(level,2*19+11,46);
    setField(level,6*19+16,46);
    setField(level,7*19+15,46);
    setField(level,5*19+11,46);
    setField(level,6*19+12,46);
    setField(level,7*19+11,46);
    setField(level,10*19+11,46);

    setField(level,5*19+16,25);

	setField(level,5*19+10,45);
	setField(level,7*19+10,45);

	setField(level,6*19+9,35);

	setField(level,6*19+3,33);
    setParx(level,6*19+3,9);
    setPary(level,6*19+3,6);

	setField(level,3*19+4,23);
    setParx(level,3*19+4,3);
    setPary(level,3*19+4,6);

	setField(level,7*19+3,13);
	setField(level,7*19+4,16);

	for(i=6;i<19;i+=2){
    	if(i>13) alloc_balaban(i,0,0,&level->balabans);
    	alloc_balaban(i,13,0,&level->balabans);
	}

    set_player(&level->player,4,9,4,2);  
}

static void getLevel10(Level* level)
{
    gint i,j;

    
    level->level=L10;

	level->max=25; 
    set_map(&level->map,26,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=12;i<20;i++){
    	for(j=12;j<15;j++){
			alloc_balaban(i,j,1,&level->balabans);
		}
	}
    for(i=5;i<26;i++){
	    if(i<20)setField(level,3*26+i,2);
	    setField(level,11*26+i,2);
	}

	setField(level,4*26+5,2);
	setField(level,9*26+5,2);
	setField(level,10*26+5,2);

	setField(level,6*26+0,46);
	setField(level,7*26+0,3);
	setField(level,8*26+0,46);

	setField(level,6*26+2,46);
	setField(level,7*26+2,3);
	setField(level,7*26+1,46);

	setField(level,5*26+3,46);
	setField(level,6*26+3,46);
	setField(level,6*26+4,46);

	setField(level,8*26+4,46);
	setField(level,7*26+4,25);

	setField(level,1*26+7,35);
	setField(level,1*26+10,35);

    setField(level,1*26+20,34);
	setParx(level,1*26+20,7);
    setPary(level,1*26+20,1);
	setField(level,1*26+23,34);
	setParx(level,1*26+23,10);
    setPary(level,1*26+23,1);

    setField(level,6*26+18,22);
	setParx(level,6*26+18,20);
    setPary(level,6*26+18,1);
	setField(level,7*26+17,22);
	setParx(level,7*26+17,23);
    setPary(level,7*26+17,1);

	setField(level,6*26+20,16);
	setField(level,7*26+23,16);
	setField(level,6*26+19,12);
	for(i=18;i<23;i++)setField(level,7*26+i,12);

	for(i=2;i<6;i++)setField(level,i*26+20,11);
	for(i=2;i<7;i++)setField(level,i*26+23,11);

	setField(level,10*26+25,5);

	setField(level,7*26+10,37);    
    setField(level,7*26+11,38);    
    setField(level,7*26+12,37);    
    setField(level,7*26+13,38);    
    setField(level,7*26+14,39);    
    setField(level,7*26+15,38);

    set_player(&level->player,1,3,1,1);  
}

static gboolean level11_end(Level* level)
{
	if(level->map.field[17*30+23]!=0) return COUNT_END(level);
    return TRUE;
}

static void getLevel11(Level* level)
{
    gint i,j;

    gint koule[48][2]={{0,16},{0,19},{0,21},{0,22},{0,25},{1,16},{1,28},{1,20},{1,25},{1,26},
		{1,29},{2,17},{2,20},{2,22},{2,26},{2,17},{2,20},{2,22},{2,24},{2,26},
		{3,17},{3,19},{3,21},{3,23},{3,25},{3,27},{3,29},{4,26},{4,28},{5,27},
		{5,29},{7,27},{8,26},{8,28},{9,27},{9,29},{10,26},{10,28},{11,27},{11,29},
		{12,26},{12,28},{13,27},{13,29},{14,26},{14,28},{15,27},{15,29}
		};
    
    level->level=L11;

	level->max=52; 
    set_map(&level->map,30,20);
    level->endFunc=level11_end;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<4;j++){
			if(i<2){
				alloc_balaban(i,j,2,&level->balabans);
			}else{
				if(i>7)alloc_balaban(i,j,1,&level->balabans);
				else alloc_balaban(i,j,0,&level->balabans);
			}
		}
	}
    for(i=0;i<48;i++) setField(level,koule[i][0]*30+koule[i][1],46);
	setField(level,0*30+29,3);
	setField(level,3*30+26,3);
	setField(level,5*30+26,3);
	setField(level,5*30+28,3);
	setField(level,7*30+29,3);
	setField(level,10*30+27,3);
	setField(level,11*30+26,3);


    for(i=0;i<30;i++){
	    if(i>10 && i<16){
			setField(level,i*30+25,46);
			setField(level,i*30+24,3);
			setField(level,i*30+23,5);
		}
	    if(i<4)setField(level,4*30+i,2);
	    if(i>3 && i<13)setField(level,4*30+i,1);
	    if(i>12 && i<26)setField(level,4*30+i,2);
	    if(i>11 && i<15)setField(level,7*30+i,2);
	    if(i>14 && i<18)setField(level,7*30+i,1);
	    if(i>17 && i<22)setField(level,7*30+i,2);
		if(i>4 && i<11)setField(level,12*30+i,2);
		if(i>21 && i<25)setField(level,16*30+i,1);
		if(i>24)setField(level,16*30+i,2);

		if(i>4 && i<11)setField(level,i*30+25,2);
		if(i>6 && i<11)setField(level,i*30+12,2);
		if(i>13 && i<16)setField(level,i*30+12,2);
		if(i>6 && i<10)setField(level,i*30+21,2);
		if(i>9 && i<13)setField(level,i*30+21,1);
  		if(i>12 && i<17)setField(level,i*30+21,2);
		if(i>16 && i<20)setField(level,i*30+21,1);
	}

    for(i=22;i<30;i++){
    	for(j=17;j<20;j++){
			if(i!=23 || j!=17) alloc_balaban(i,j,4,&level->balabans);
		}
	}

	setField(level,11*30+12,1);    
	setField(level,12*30+11,1);    
	setField(level,13*30+12,1);    

    setField(level,12*30+12,20);
	setParx(level,12*30+12,45);

    setField(level,8*30+16,20);
	setParx(level,8*30+16,45);

    setField(level,11*30+20,20);
	setParx(level,11*30+20,45);

    setField(level,18*30+20,20);
	setParx(level,18*30+20,42);

    setField(level,17*30+23,20);
	setParx(level,17*30+23,50);

    set_player(&level->player,13,2,2,2);  
}

static gboolean level12_end(Level* level)
{
	if(level->map.field[16*27+7]==0) return COUNT_END(level);
    return TRUE;
}

static void getLevel12(Level* level)
{
    gint i,j;

    gint koule[34][2]={{0,11},{0,13},{0,19},{0,21},{0,12},{1,14},{1,17},{1,22},{1,26},{2,13},
		{1,16},{2,20},{2,21},{2,22},{3,14},{3,18},{3,23},{3,25},{4,15},{4,19},
		{4,24},{5,23},{5,25},{6,23},{6,25},{6,26},{7,22},{7,24},{8,21},{8,25},
		{9,22},{9,24},{10,23},{1,19}
		};
    
    level->level=L12;

	level->max=54; 
    set_map(&level->map,27,18);
    level->endFunc=level12_end;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<5;j++){
			if(i<6) alloc_balaban(i,j,0,&level->balabans);
			else alloc_balaban(i,j,1,&level->balabans);
		}
		if(i<6){
			for(j=12;j<18;j++){
				alloc_balaban(i,j,1,&level->balabans);
			}
		}
	}
    for(i=0;i<34;i++) setField(level,koule[i][0]*27+koule[i][1],46);
	setField(level,7*27+23,3);
	setField(level,8*27+22,3);
	setField(level,8*27+23,3);
	setField(level,8*27+24,3);
	setField(level,9*27+23,3);
	
	setField(level,5*27+0,1);

    for(i=0;i<27;i++){
	    if(i>12 && i<18){
			setField(level,i*27+24,3);
			setField(level,i*27+25,3);
			setField(level,i*27+26,3);
		}
	    if(i>0 && i<19)setField(level,5*27+i,2);
	    if(i>5 && i<10)setField(level,i*27+18,2);
	    if(i>20)setField(level,12*27+i,2);
	    if(i<7)setField(level,11*27+i,2);
	    if(i>11 && i<18)setField(level,i*27+6,1);
	}

	setField(level,10*27+19,2);    
	setField(level,11*27+20,2);    

    setField(level,13*27+7,20);
	setParx(level,13*27+7,52);

    setField(level,16*27+7,20);
	setParx(level,16*27+7,52);
    set_player(&level->player,10,4,13,10);  
}

static gboolean level13_end(Level* level)
{
	if(level->map.field[16*27+17]==0) return COUNT_END(level);
    return TRUE;
}

static void getLevel13(Level* level)
{
    gint i,j;

    gint koule[24][2]={{0,11},{0,13},{1,14},{2,13},{3,14},{4,15},{6,23},{6,25},{6,26},{7,22},
					{7,24},{8,22},{8,25},{9,22},{9,24},{10,23},{1,19},{4,19},{5,19},{3,21},
					{4,18},{4,20},{3,22},{4,21}
		};
    
    level->level=L13;

	level->max=30; 
    set_map(&level->map,27,18);
    level->endFunc=level13_end;

    level->balabans=NULL;
    for(i=0;i<11;i++){
    	for(j=0;j<5;j++){
            if(i!=10 || j!=4){
				if(i<6) alloc_balaban(i,j,0,&level->balabans);
				else alloc_balaban(i,j,1,&level->balabans);
			}
		}
		if(i<8){
			for(j=12;j<18;j++){
				alloc_balaban(i,j,i==7?0:4,&level->balabans);
			}
		}
	}
    for(i=0;i<24;i++) setField(level,koule[i][0]*27+koule[i][1],46);
	setField(level,7*27+23,3);
	setField(level,8*27+23,3);
	setField(level,8*27+24,3);
	setField(level,9*27+23,3);
	
	setField(level,5*27+0,1);

    for(i=0;i<27;i++){
	    if(i>14 && i<18){
			setField(level,i*27+24,3);
			setField(level,i*27+25,3);
			setField(level,i*27+26,3);
		}
	    if(i>0 && i<19)setField(level,5*27+i,2);
	    if(i>5 && i<10)setField(level,i*27+18,2);
	    if(i<9)setField(level,11*27+i,2);
	    if(i>11 && i<18)setField(level,i*27+8,1);
	}

	setField(level,10*27+19,2);    
	setField(level,11*27+20,2);    

    setField(level,13*27+9,20);
	setParx(level,13*27+9,6);

    setField(level,16*27+9,20);
	setParx(level,16*27+9,6);

    setField(level,13*27+11,20);
	setParx(level,13*27+11,6);

    setField(level,16*27+11,20);
	setParx(level,16*27+11,6);

    setField(level,13*27+13,20);
	setParx(level,13*27+13,7);

    setField(level,16*27+13,20);
	setParx(level,16*27+13,7);

    setField(level,13*27+15,20);
	setParx(level,13*27+15,8);

    setField(level,16*27+15,20);
	setParx(level,16*27+15,8);

    setField(level,13*27+17,20);
	setParx(level,13*27+17,8);

    setField(level,16*27+17,20);
	setParx(level,16*27+17,9);


    set_player(&level->player,10,4,13,10);  
}

static void getLevel14(Level* level)
{
    gint i,j;

     
    level->level=L14;

	level->max=18; 
    set_map(&level->map,40,30);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<10;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
		 alloc_balaban(39,i*3+1,0,&level->balabans);
	}
    for(i=0;i<13;i++) setField(level,i*40+16,44);

    setField(level,25*40+10,33);
    setField(level,26*40+10,21);
	setParx(level,25*40+10,12);
	setPary(level,25*40+10,25);
	setParx(level,26*40+10,10);
	setPary(level,26*40+10,25);
    setField(level,25*40+12,35);

    setField(level,27*40+20,33);
    setField(level,28*40+20,21);
	setParx(level,27*40+20,22);
	setPary(level,27*40+20,27);
	setParx(level,28*40+20,20);
	setPary(level,28*40+20,27);
    setField(level,27*40+22,35);

    setField(level,25*40+30,33);
    setField(level,26*40+30,21);
	setParx(level,25*40+30,32);
	setPary(level,25*40+30,25);
	setParx(level,26*40+30,30);
	setPary(level,26*40+30,25);
    setField(level,25*40+32,35);


    set_player(&level->player,14,8,200,10);  
}

static gboolean level15_end(Level* level)
{
	gint naboju=0;
	gint i;
	
	if(level->map.field[9*27+14]!=0) naboju +=6*3;
	for(i=2;i<12;i++){
		if(level->map.field[i*27+0]!=0) naboju--;
	}
	if(level->map.field[14*27+19]!=0) naboju--;
	if(level->map.field[8*27+25]!=0) naboju--;
	if(level->map.field[9*27+25]!=0) naboju--;

    return (COUNT_END_POCET(level)+naboju)>=0;
}

static void getLevel15(Level* level)
{
    gint i,j;

    gint koule[19][2]={{0,15},{0,17},{1,15},{1,16},{1,18},{2,15},{2,16},{2,17},{2,18},{4,13},
					{4,14},{4,15},{4,16},{5,13},{6,12},{6,13},{3,9},{7,16},{9,26}
		};
    
    level->level=L15;

	level->max=76; 
    set_map(&level->map,27,15);
    level->endFunc=level15_end;

    level->balabans=NULL;
    for(i=0;i<27;i++){
    	for(j=0;j<15;j++){
            if(i>9 && i<15 && j>7 && (i!=14 || j!=9)){
				alloc_balaban(i,j,4,&level->balabans);
			}
            if(i>23 && i<26 && j>9 && j<11){
				setField(level,j*27+i,3);
			}
		}
		if(i>1 && i<12)setField(level,i*27+0,1);
		if(i>0 && i<15)setField(level,i*27+1,2);
		if(i!=3 && i<15)setField(level,i*27+7,2);
		if(i!=3 && i<15)setField(level,i*27+9,2);
		if(i>9 && i<16)setField(level,7*27+i,2);
		if(i!=10 && i>7 && i<15)setField(level,i*27+15,2);
		if(i>16 && i<19)setField(level,7*27+i,2);
		if(i>15 && i<19)alloc_balaban(i,14,0,&level->balabans);
		if(i>0 && i<14)setField(level,i*27+19,2);
		if(i>0 && i<14)setField(level,i*27+21,2);
		if(i>0 && i<8)setField(level,i*27+25,2);
		if(i!=8 && i>0 && i<14)setField(level,i*27+23,2);

	}
    for(i=0;i<19;i++) setField(level,koule[i][0]*27+koule[i][1],46);
	setField(level,3*27+7,1);
	setField(level,12*27+0,5);
	setField(level,13*27+0,5);
	setField(level,14*27+0,5);
	setField(level,4*27+8,25);
	setField(level,13*27+0,5);
	setField(level,14*27+0,5);
	setField(level,10*27+15,1);
    setField(level,14*27+19,1);
    setField(level,1*27+20,2);
    setField(level,1*27+22,2);
    setField(level,1*27+24,2);
    setField(level,9*27+24,2);
	alloc_balaban(22,2,0,&level->balabans);
	alloc_balaban(24,2,0,&level->balabans);
	alloc_balaban(22,3,0,&level->balabans);
	alloc_balaban(24,3,0,&level->balabans);
	setField(level,8*27+22,6);
	setField(level,8*27+26,25);
	setField(level,11*27+22,25);
	setField(level,14*27+19,1);
	setField(level,14*27+23,1);
	setField(level,14*27+24,25);
	setField(level,13*27+8,3);
	setField(level,14*27+8,3);
	setField(level,8*27+25,1);
	setField(level,9*27+25,1);

	setField(level,4*27+4,37);    
    setField(level,5*27+4,38);    
    setField(level,6*27+4,37);    
    setField(level,7*27+4,38);    
    setField(level,8*27+4,39);    
    setField(level,9*27+4,38);

	setField(level,13*27+24,5);
	setField(level,13*27+25,5);
	setField(level,14*27+25,5);

	setField(level,5*27+14,23);
	setField(level,6*27+14,11);
	setField(level,8*27+14,16);
	setField(level,8*27+13,14);
	setField(level,9*27+13,11);
	setField(level,10*27+13,13);
	setField(level,10*27+14,16);
	setField(level,9*27+14,19);

 	setParx(level,5*27+14,14);
 	setPary(level,5*27+14,9);


    set_player(&level->player,4,2,2,1);  
}

static void getLevel16(Level* level)
{
    gint i,j;

    gint koule[13][2]={{0,23},{1,19},{1,22},{2,20},{2,22},{3,19},{3,21},{3,23},{4,20},{4,22},
					{5,24},{6,19},{7,19}
		};
    
    level->level=L16;

	level->max=23; 
    set_map(&level->map,25,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<25;i++){
    	for(j=0;j<20;j++){
            if(i>18 && j>9 && j<15){
				alloc_balaban(i,j,1,&level->balabans);
			}
			if(i>18 && j>7 && j<10){
				setField(level,j*25+i,44);
			}
		}
		if(i<6)setField(level,i*25+18,2);
		if(i>7 && i<16)setField(level,i*25+18,2);
		if(i>18)setField(level,15*25+i,2);
		if(i>18 && i<24)setField(level,5*25+i,2);
		if(i>15 && i<20)setField(level,i*25+18,25);
		if(i>15 && i<20)setField(level,i*25+24,5);
	}
    for(i=0;i<13;i++) setField(level,koule[i][0]*25+koule[i][1],46);
	setField(level,0*25+20,3);
	setField(level,0*25+24,3);
	setField(level,1*25+23,5);
	setField(level,1*25+24,5);
	setField(level,6*25+18,44);
	setField(level,7*25+18,44);
	setField(level,1*25+1,44);
	setField(level,6*25+1,44);
    setField(level,18*25+1,44);
    setField(level,18*25+6,44);
    setField(level,18*25+11,44);
    setField(level,18*25+16,44);

    set_player(&level->player,13,7,3,1);  
}

static void getLevel17(Level* level)
{
    gint i,j;

    gint koule[14][2]={{2,7},{3,8},{3,10},{4,8},{4,9},{4,10},{4,11},{5,8},{6,6},{6,9},
					{6,10},{7,6},{4,5},{5,10}
		};
    
    level->level=L17;

	level->max=39; 
    set_map(&level->map,20,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<20;i++){
    	for(j=0;j<17;j++){
            if(i>5 && i<13 && j>10){
				alloc_balaban(i,j,4,&level->balabans);
			}
			if(i>13 && i<17 && j>1){
				setField(level,j*20+i,25);
			}
		}
		if(i>0 && i<17 && i!=4)setField(level,i*20+5,2);
		if(i>1 && i<17 && i!=3 && i!=7)setField(level,i*20+13,2);
		if(i>0 && i<17)setField(level,i*20+17,2);
		if(i>5 && i<17)setField(level,1*20+i,2);
		if(i>5 && i<13 && i!=10)setField(level,10*20+i,2);

	}
    for(i=0;i<14;i++) setField(level,koule[i][0]*20+koule[i][1],46);
	setField(level,3*20+13,1);
	setField(level,7*20+13,1);
	setField(level,10*20+10,1);

	setField(level,6*20+2,37);    
    setField(level,7*20+2,38);    
    setField(level,8*20+2,37);    
    setField(level,9*20+2,38);    
    setField(level,10*20+2,39);    
    setField(level,11*20+2,38);

    set_player(&level->player,3,8,10,10);  
}

static void getLevel18(Level* level)
{
    gint i,j;

    gint koule[10][2]={{13,9},{14,8},{14,10},{14,12},{15,7},{15,9},{15,11},{15,12},{16,6},{16,12}
		};
    
    level->level=L18;

	level->max=35; 
    set_map(&level->map,23,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<23;i++){
    	for(j=0;j<17;j++){
            if(i>5 && i<13 && j>3 && j<10){
				alloc_balaban(i,j,4,&level->balabans);
			}
			if(i>5 && i<13 && j>9 && j<12){
				setField(level,j*23+i,3);
			}
            if(i>13 && i<17 && j>1 && j<12){
				setField(level,j*23+i,25);
			}
		}
		if(i>0 && i<13)setField(level,i*23+5,2);
		if(i>3 && i<12)setField(level,i*23+13,1);
		if(i>1 && i<12)setField(level,i*23+17,1);
		if(i>10 && i<16)setField(level,i*23+21,2);
		if(i>6 && i<18)setField(level,1*23+i,2);
		if(i>5 && i<14)setField(level,3*23+i,2);
        if(i>5 && i<18)setField(level,12*23+i,2);
        if(i>13 && i<21)setField(level,15*23+i,2);

	}
    for(i=0;i<10;i++) setField(level,koule[i][0]*23+koule[i][1],46);
	setField(level,1*23+6,1);
    setField(level,3*23+11,1);
    setField(level,10*23+5,1);

	setField(level,6*23+2,37);    
    setField(level,7*23+2,38);    
    setField(level,8*23+2,37);    
    setField(level,9*23+2,38);    
    setField(level,10*23+2,39);    
    setField(level,11*23+2,38);

    set_player(&level->player,3,8,8,5);  
}

static void getLevel19(Level* level)
{
    gint i,j;

    gint koule[15][2]={{2,7},{3,8},{3,11},{4,8},{4,9},{4,10},{4,11},{5,8},{6,6},{6,9},
					{6,10},{7,6},{4,5},{5,10},{2,9}
		};
    
    level->level=L19;

	level->max=40; 
    set_map(&level->map,20,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<20;i++){
    	for(j=0;j<17;j++){
            if(i>5 && i<13 && j>10){
				alloc_balaban(i,j,4,&level->balabans);
			}
			if(i>13 && i<17 && j>1){
				setField(level,j*20+i,25);
			}
		}
		if(i>0 && i<17 && i!=4)setField(level,i*20+5,2);
		if(i>1 && i<17 && i!=3 && i!=7)setField(level,i*20+13,2);
		if(i>0 && i<17)setField(level,i*20+17,2);
		if(i>5 && i<17)setField(level,1*20+i,2);
		if(i>5 && i<13 && i!=10)setField(level,10*20+i,2);

	}
    for(i=0;i<14;i++) setField(level,koule[i][0]*20+koule[i][1],46);
	setField(level,3*20+13,1);
	setField(level,7*20+13,1);
	setField(level,10*20+10,1);

	setField(level,6*20+2,37);    
    setField(level,7*20+2,38);    
    setField(level,8*20+2,37);    
    setField(level,9*20+2,38);    
    setField(level,10*20+2,39);    
    setField(level,11*20+2,38);

    set_player(&level->player,3,8,40,0);  
}

static void getLevel20(Level* level)
{
    gint i,j;

    gint koule[34][2]={{11,12},{13,8},{13,16},{14,13},{14,16},{15,11},{15,16},{18,11},{18,14},{18,15},
					{19,10},{19,13},{19,14},{19,16},{19,17},{20,14},{20,15},{20,18},{21,13},{21,15},
					{21,17},{24,17},{25,12},{25,21},{26,11},{26,12},{26,13},{26,16},{27,12},{29,18},
					{14,20},{13,17},{12,12},{12,11}
		};
    
    level->level=L20;

	level->max=106; 
    set_map(&level->map,40,30);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<40;i++){
    	for(j=0;j<30;j++){
            if(i<10 && j>24){
				alloc_balaban(i,j,4,&level->balabans);
			}
            if(i<10 && j<3){
				setField(level,j*40+i,5);    
			}
			if(i<10 && j<5 && j>2){
				setField(level,j*40+i,3);    
			}
            if(i>29 && j<5){
				alloc_balaban(i,j,2,&level->balabans);
			}
            if(i>29 && j>24 && j<27){
				setField(level,j*40+i,3);    
			}
			if(i>29 && j>26){
				setField(level,j*40+i,5);    
			}
            if(j>21 && i<17 && i>10){
				alloc_balaban(i,j,1,&level->balabans);
			}
			if(j>21 && i<25 && i>21){
				setField(level,j*40+i,5);   
			}
			if(j>21 && i<29 && i>25){
				setField(level,j*40+i,3);   
			}
		}
		if(i<30 && i!=12)setField(level,i*40+10,2);
		if(i<30 && i!=18)setField(level,i*40+29,2);
		if(i>10 && i<29 && i!=13)setField(level,8*40+i,2);
		if(i>10 && i<29 && i!=14 && i!=25)setField(level,21*40+i,2);

 	    if(i>8 && i<16 && i!=11)setField(level,i*40+17,2);
 	    if(i>13 && i<21 && i!=17)setField(level,i*40+22,2);
		if(i>10 && i<17 && i!=14)setField(level,15*40+i,2);
		if(i>22 && i<29 && i!=26)setField(level,14*40+i,2);
	}
    for(i=0;i<34;i++) setField(level,koule[i][1]*40+koule[i][0],46);

	setField(level,3*40+18,3);
	setField(level,4*40+18,3);
	setField(level,3*40+19,5);
	setField(level,4*40+19,5);

    set_player(&level->player,15,18,7,7);  
}

static void getLevel21(Level* level)
{
    gint i,j;

    
    level->level=L21;

	level->max=34; 
    set_map(&level->map,32,15);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<4;i++){
    	for(j=0;j<4;j++){
            alloc_balaban(i,j,4,&level->balabans);
			alloc_balaban(28+i,j,4,&level->balabans);            
			alloc_balaban(i,11+j,4,&level->balabans);            
			alloc_balaban(28+i,11+j,4,&level->balabans);            
		}
	}

    setField(level,6*32+16,17);
    setParx(level,6*32+16,16);
    setPary(level,6*32+16,14);
    setField(level,14*32+16,18);
    setParx(level,14*32+16,1);

    setField(level,7*32+17,17);
    setParx(level,7*32+17,0);
    setPary(level,7*32+17,7);
    setField(level,7*32+0,18);
    setParx(level,7*32+0,2);

    setField(level,8*32+16,17);
    setParx(level,8*32+16,16);
    setPary(level,8*32+16,0);
    setField(level,0*32+16,18);
    setParx(level,0*32+16,3);

    setField(level,7*32+15,17);
    setParx(level,7*32+15,31);
    setPary(level,7*32+15,7);
    setField(level,7*32+31,18);
    setParx(level,7*32+31,4);

    setField(level,7*32+24,17);
    setParx(level,7*32+24,16);
    setPary(level,7*32+24,7);
    setField(level,7*32+16,18);
    setParx(level,7*32+16,5);

    set_player(&level->player,13,8,140,100);  
}

static void getLevel22(Level* level)
{
    gint i,j;

    
    level->level=L22;

	level->max=25; 
    set_map(&level->map,32,19);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<4;i++){
    	for(j=0;j<3;j++){
            alloc_balaban(i,j,4,&level->balabans);
			alloc_balaban(28+i,j,4,&level->balabans);            
			alloc_balaban(i,16+j,4,&level->balabans);            
			alloc_balaban(28+i,16+j,4,&level->balabans);            
		}
	}

    setField(level,8*32+16,17);
    setParx(level,8*32+16,16);
    setPary(level,8*32+16,18);
    setField(level,18*32+16,18);
    setParx(level,18*32+16,1);

    setField(level,9*32+17,17);
    setParx(level,9*32+17,0);
    setPary(level,9*32+17,9);
    setField(level,9*32+0,18);
    setParx(level,9*32+0,2);

    setField(level,10*32+16,17);
    setParx(level,10*32+16,16);
    setPary(level,10*32+16,0);
    setField(level,0*32+16,18);
    setParx(level,0*32+16,3);

    setField(level,9*32+15,17);
    setParx(level,9*32+15,31);
    setPary(level,9*32+15,9);
    setField(level,9*32+31,18);
    setParx(level,9*32+31,4);

    setField(level,9*32+26,17);
    setParx(level,9*32+26,16);
    setPary(level,9*32+26,9);
    setField(level,9*32+16,18);
    setParx(level,9*32+16,5);

    set_player(&level->player,13,6,40,100);  
}

static void getLevel23(Level* level)
{
    gint i;
    
    level->level=L23;

	level->max=12; 
    set_map(&level->map,36,16);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<16;i++){
		alloc_balaban(35,i,3,&level->balabans);            
	}
 
    setField(level,1*36+0,3);
    setField(level,1*36+1,3);
    setField(level,1*36+2,3);
    setField(level,1*36+3,3);
    setField(level,1*36+4,3);

    setField(level,1*36+4,46);
    setField(level,7*36+4,46);
	setField(level,7*36+14,46);
	setField(level,13*36+4,46);

    set_player(&level->player,4,15,5,3);  
}

static void getLevel24(Level* level)
{
    gint i,j;

    gint koule[16][2]={{4,0},{5,1},{6,1},{7,1},{7,2},{9,3},{8,5},{8,7},{7,8},{4,9},
					{4,10},{4,11},{2,12},{4,13},{5,14},{4,15}
		};
    
    level->level=L24;

	level->max=26; 
    set_map(&level->map,30,16);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<16;i++){
    	for(j=25;j<30;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
		if(i<4)setField(level,0*30+i,3);
		if(i<5)setField(level,1*30+i,3);
		if(i<7){
        	setField(level,3*30+i,44);
			setField(level,5*30+i,44);
 	    	setField(level,7*30+i,44);
		}
	}
    for(i=0;i<16;i++) setField(level,koule[i][1]*30+koule[i][0],46);

	setField(level,7*30+12,37);    
    setField(level,7*30+13,38);    
    setField(level,7*30+14,37);    
    setField(level,7*30+15,38);    
    setField(level,7*30+16,39);    
    setField(level,7*30+17,38);

    set_player(&level->player,1,13,35,5);  
}

static void getLevel25(Level* level)
{
    gint i,j;

    gint koule[28][2]={{0,10},{0,25},{1,11},{1,24},{2,12},{2,23},{3,13},{3,15},{3,22},{4,15},
					{4,18},{4,21},{5,15},{5,20},{6,16},{6,17},{6,18},{6,19},{7,17},{7,20},
					{8,16},{8,18},{8,19},{8,20},{9,15},{9,20},{10,14},{10,21}
		};
    
    level->level=L25;

	level->max=35; 
    set_map(&level->map,32,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=11;j<17;j++){
			alloc_balaban(i,j,3,&level->balabans);
			alloc_balaban(i+26,j,3,&level->balabans);
		}
	}
    for(i=0;i<28;i++) setField(level,koule[i][0]*32+koule[i][1],46);

    set_player(&level->player,17,8,100,100);  
}

static void getLevel26(Level* level)
{
    gint i,j;

    gint koule[8][2]={{2,27},{7,21},{10,27},{11,32},{13,29},{13,31},{14,28},{14,29}
		};
    gint zed[8][2]={{1,25},{3,31},{6,18},{8,29},{12,32},{13,23},{14,23},{15,23}
		};
    
    level->level=L26;

	level->max=44; 
    set_map(&level->map,34,16);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<16;j++){
			if(i<4) alloc_balaban(i,j,3,&level->balabans);
			else setField(level,j*34+i,1);
            if(i<3 && j<3) setField(level,(j+13)*34+i+24,3);
		}
	}
    for(i=0;i<8;i++) setField(level,koule[i][0]*34+koule[i][1],46);
    for(i=0;i<8;i++) setField(level,zed[i][0]*34+zed[i][1],2);

    set_player(&level->player,15,0,12,12);  
}

static void getLevel27(Level* level)
{
    gint i,j;

    
    level->level=L27;

	level->max=49; 
    set_map(&level->map,20,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<20;i++){
    	for(j=0;j<17;j++){
			if((j>0 && i<19 && i>0 && j!=8 && j!=10) || j==9) setField(level,j*20+i,2);
			if(j>2 && j<5 && i>8 && i<14){
				setField(level,j*20+i,0);
				alloc_balaban(i,j,4,&level->balabans);
			}
			if(j>11 && i>2 && i<7){
				setField(level,j*20+i,0);
				alloc_balaban(i,j,0,&level->balabans);
			}
			if(j>11 && i>14 && i<18){
				setField(level,j*20+i,0);
				alloc_balaban(i,j,2,&level->balabans);
			}
		}
		if(i>1 && i<8) setField(level,i*20+19,3);
		if(i>3 && i<9) setField(level,7*20+i,0);
		if(i>3 && i<9) setField(level,9*20+i,0);
	}

    setField(level,0*20+6,23);
    setParx(level,0*20+6,7);
    setPary(level,0*20+6,3);

    setField(level,1*20+6,11);
    setField(level,2*20+6,11);
    setField(level,3*20+6,11);
    setField(level,4*20+6,13);
    setField(level,4*20+7,16);
    setField(level,3*20+7,19);
    setField(level,3*20+8,1);

    setField(level,8*20+12,21);
    setParx(level,8*20+12,12);
    setPary(level,8*20+12,6);

    setField(level,7*20+12,11);
    setField(level,6*20+12,19);
    setField(level,5*20+12,1);

	setField(level,8*20+4,46);
	setField(level,8*20+5,1);
	setField(level,8*20+7,1);
	setField(level,8*20+8,46);

    setField(level,12*20+0,1);
	setField(level,15*20+0,1);
	setField(level,16*20+0,1);
	setField(level,14*20+1,0);
	setField(level,14*20+2,1);

	setField(level,14*20+7,1);
	setField(level,14*20+8,5);
	setField(level,15*20+8,5);
	setField(level,16*20+8,5);

	setField(level,15*20+14,1);
	setField(level,15*20+13,3);
	setField(level,16*20+13,3);
	setField(level,16*20+18,1);

    set_player(&level->player,6,8,1,6);  
}

static void getLevel28(Level* level)
{
    gint i,j;

    
    level->level=L28;

	level->max=24; 
    set_map(&level->map,60,40);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=0;j<6;j++){
			alloc_balaban(i+54,j,(i==0 || j==5)?0:4,&level->balabans);
			alloc_balaban(i,j+34,(i==5 || j<2)?0:4,&level->balabans);
		}
	}

    setField(level,0*60+0,17);
    setParx(level,0*60+0,59);
    setPary(level,0*60+0,39);
    setField(level,39*60+59,18);

    set_player(&level->player,29,19,50,60);  
}

static void getLevel29(Level* level)
{
    gint i,j;

    
    level->level=L29;

	level->max=14; 
    set_map(&level->map,50,30);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=0;j<6;j++){
			alloc_balaban(i,j,4,&level->balabans);
			alloc_balaban(i,j+24,4,&level->balabans);
		}
	}
    for(i=0;i<10;i++){
    	setField(level,i*3*50+24,6);
        setField(level,i*3*50+70,6);
        setField(level,i*3*50+78,6);
        setField(level,i*3*50+116,6);
        setField(level,i*3*50+132,6);
        setField(level,i*3*50+36,6);
    }

	setField(level,14*50+25,44);
    setField(level,18*50+25,44);

    set_player(&level->player,24,16,50,60);  
}

static void getLevel30(Level* level)
{
    gint i,j;

    
    level->level=L30;

	level->max=19; 
    set_map(&level->map,50,30);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=0;j<6;j++){
			alloc_balaban(i,j,4,&level->balabans);
			alloc_balaban(i,j+24,3,&level->balabans);
		}
	}
    for(i=0;i<10;i++){
    	setField(level,i*3*50+24,6);
        setField(level,i*3*50+70,6);
        setField(level,i*3*50+78,6);
        setField(level,i*3*50+116,6);
        setField(level,i*3*50+132,6);
        setField(level,i*3*50+36,6);
    }

    set_player(&level->player,24,14,50,60);  
}

static void getLevel31(Level* level)
{
    gint i,j;

    
    level->level=L31;

	level->max=24; 
    set_map(&level->map,50,30);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<30;i++){
    	for(j=0;j<3;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
	}
    for(i=0;i<10;i++){
    	setField(level,i*3*50+24,6);
        setField(level,i*3*50+70,6);
        setField(level,i*3*50+78,6);
        setField(level,i*3*50+116,6);
        setField(level,i*3*50+132,6);
        setField(level,i*3*50+36,6);
        setField(level,i*3*50+90,6);
        setField(level,i*3*50+144,6);

    }

    set_player(&level->player,24,14,100,60);  
}

static void getLevel32(Level* level)
{
    gint i,j;

    
    level->level=L32;

	level->max=38; 
    set_map(&level->map,50,30);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<30;i++){
    	for(j=0;j<5;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
	}
    for(i=0;i<10;i++){
    	setField(level,i*3*50+24,6);
        setField(level,i*3*50+70,6);
        setField(level,i*3*50+78,6);
        setField(level,i*3*50+116,6);
        setField(level,i*3*50+132,6);
        setField(level,i*3*50+36,6);
        setField(level,i*3*50+90,6);
        setField(level,i*3*50+144,6);
		setField(level,i*3*50+48,6);
    }

    set_player(&level->player,24,14,100,60);  
}

static gboolean level33_end(Level* level)
{   
	gint pocet=COUNT_END_POCET(level);
	if(level->map.field[10*17+0]!=0) pocet+=9;
	if(level->map.field[12*17+4]!=0) pocet+=9;
	if(level->map.field[10*17+8]!=0) pocet+=9;
	if(level->map.field[10*17+12]!=0) pocet+=9;
	if(level->map.field[15*17+16]!=0) pocet+=3;

	if(level->map.field[9*17+0]!=0) pocet-=1;
	if(level->map.field[11*17+4]!=0) pocet-=1;
	if(level->map.field[9*17+8]!=0) pocet-=1;
	if(level->map.field[9*17+12]!=0) pocet-=1;
	if(level->map.field[14*17+16]!=0) pocet-=1;

	if(level->map.field[2*17+16]!=0) pocet-=1;
	if(level->map.field[3*17+16]!=0) pocet-=1;
	if(level->map.field[5*17+16]!=0) pocet-=1;

    return pocet>=0;
}

static void getLevel33(Level* level)
{
    gint i,j;

    
    level->level=L33;

	level->max=36; 
    set_map(&level->map,17,20);
    level->endFunc=level33_end;

    level->balabans=NULL;
    for(i=2;i<19;i++){
    	for(j=0;j<16;j++){
			setField(level,i*17+j,2);
		}
        if(i>2){
			setField(level,i*17+0,0);
			setField(level,i*17+4,0);
			if(i<8)setField(level,i*17+5,0);
			setField(level,i*17+8,0);
			setField(level,i*17+12,0);
			setField(level,i*17+16,0);
        }

		if(i>2 && i<9)alloc_balaban(0,i,4,&level->balabans);
		if(i>2 && i<11)alloc_balaban(4,i,4,&level->balabans);
        if(i>2 && i<8)alloc_balaban(5,i,4,&level->balabans);
        if(i>2 && i<9)alloc_balaban(8,i,4,&level->balabans);
		if(i>2 && i<9)alloc_balaban(12,i,4,&level->balabans);
		if(i>5 && i<14)alloc_balaban(16,i,0,&level->balabans);
        if(i<13)alloc_balaban(i,0,1,&level->balabans);

        if(i>10 && i<18)setField(level,i*17+0,11);
        if(i>12 && i<18)setField(level,i*17+4,11);
        if(i>10 && i<18)setField(level,i*17+8,11);
        if(i>10 && i<18)setField(level,i*17+12,11);
	}

	setField(level,9*17+0,1);
    setField(level,10*17+0,19);
    setField(level,18*17+0,21);
	setParx(level,18*17+0,0);
	setPary(level,18*17+0,10);
	setField(level,13*17+1,0);
	setField(level,14*17+1,3);
	setField(level,15*17+1,0);
	setField(level,16*17+1,0);

	setField(level,11*17+4,1);
    setField(level,12*17+4,19);
    setField(level,18*17+4,21);
	setParx(level,18*17+4,4);
	setPary(level,18*17+4,12);
	setField(level,14*17+5,5);
	setField(level,15*17+5,3);
	setField(level,16*17+5,5);

	setField(level,9*17+8,1);
    setField(level,10*17+8,19);
    setField(level,18*17+8,21);
	setParx(level,18*17+8,8);
	setPary(level,18*17+8,10);
	setField(level,13*17+9,3);
	setField(level,14*17+9,5);
	setField(level,15*17+9,5);
	setField(level,16*17+9,0);

	setField(level,9*17+12,1);
    setField(level,10*17+12,19);
    setField(level,18*17+12,21);
	setParx(level,18*17+12,12);
	setPary(level,18*17+12,10);
	setField(level,13*17+13,5);
	setField(level,14*17+13,3);
	setField(level,15*17+13,0);

	setField(level,2*17+16,1);
	setField(level,3*17+16,1);
	setField(level,4*17+16,3);
	setField(level,5*17+16,1);
	setField(level,14*17+16,1);
    setField(level,15*17+16,19);
	setField(level,16*17+16,11);
	setField(level,17*17+16,11);
    setField(level,18*17+16,21);
	setParx(level,18*17+16,16);
	setPary(level,18*17+16,15);

    set_player(&level->player,0,19,0,0);  
}

static gboolean level34_end(Level* level)
{   
	if(level->map.field[1*30+1]!=0) return TRUE;

    return COUNT_END(level);
}

static void getLevel34(Level* level)
{
    gint i,j,k;

    
    level->level=L34;

	level->max=26; 
    set_map(&level->map,30,17);
    level->endFunc=level34_end;

    level->balabans=NULL;
	for(k=0;k<21;k+=4){
    	for(i=k;i<k+4;i++){
     		for(j=3;j<6;j++){
				if(i<k+3)alloc_balaban(i,j,4,&level->balabans);
                else setField(level,j*30+i,2);
                if(j==3){
					setField(level,2*30+i,1);
				}
            }

		}
		setField(level,6*30+k,2);
		setField(level,6*30+k+1,1);
		setField(level,6*30+k+2,2);
		setField(level,6*30+k+3,2);
        setField(level,7*30+k+1,20);
		setParx(level,7*30+k+1,1+k/2);
    }
	for(i=1;i<24;i+=3){
        setField(level,1*30+i,20);
		setParx(level,1*30+i,17);
	}
    setField(level,0*30+23,20);
	setParx(level,0*30+23,17);
	for(i=8;i<17;i+=3){
        setField(level,i*30+24,20);
		setParx(level,i*30+24,18);
	}
	for(i=0;i<17;i++){
        if(i>1)setField(level,i*30+25,1);
		for(j=26;j<30;j++){
			alloc_balaban(j,i,4,&level->balabans);
        }
	}

	setField(level,0*30+24,1);
    setField(level,1*30+24,1);
	setField(level,2*30+24,43);
    setField(level,3*30+24,43);
	setField(level,4*30+24,43);
    setField(level,5*30+24,43);
	setField(level,6*30+24,43);

    set_player(&level->player,0,10,100,100);  
}

static gboolean level35_end(Level* level)
{   
	if(level->map.field[21*25+21]!=0) return TRUE;

    return COUNT_END(level);
}

static void getLevel35(Level* level)
{
    gint i,j,k;

    
    level->level=L35;
    gint offset[11][3]={{6,4,0},{6,8,4},{6,12,4},{6,16,1},{6,20,0},{11,4,0},{17,4,1},{17,8,4},{17,12,4},{17,16,1},{17,20,0}};
	gint fire[12][3]={{4,5,7},{4,9,6},{4,13,5},{4,17,4},{4,21,3},{12,2,8},{21,5,9},{21,9,10},{21,13,11},{21,17,12},{21,21,13},{13,22,13}};
    gint zed[13][2]={{5,5},{5,9},{5,13},{5,17},{5,21},{12,3},{20,5},{20,9},{20,13},{20,17},{20,21},{12,22},{14,22}};


	level->max=42; 
    set_map(&level->map,25,23);
    level->endFunc=level35_end;

    level->balabans=NULL;
	for(k=0;k<11;k++){
    	for(i=0;i<3;i++){
     		for(j=0;j<3;j++){
				alloc_balaban(i+offset[k][0],j+offset[k][1],offset[k][2],&level->balabans);
            }
		}
	}
	for(k=0;k<12;k++){
        setField(level,fire[k][1]*25+fire[k][0],20);
		setParx(level,fire[k][1]*25+fire[k][0],fire[k][2]);
	}
	for(i=6;i<20;i++){
		setField(level,3*25+i,43);
		setField(level,7*25+i,43);
		setField(level,11*25+i,43);
		setField(level,15*25+i,43);
		setField(level,19*25+i,43);
	}

	for(i=3;i<23;i++){
		setField(level,i*25+5,43);
		setField(level,i*25+20,43);
	}
	for(k=0;k<13;k++){
        setField(level,zed[k][1]*25+zed[k][0],1);

	}
    setField(level,20*25+12,2);
	setField(level,21*25+12,2);
    setField(level,20*25+14,2);
	setField(level,21*25+14,2);

	for(i=20;i<23;i++){
        setField(level,i*25+10,3);
        setField(level,i*25+11,5);
        setField(level,i*25+15,3);
        setField(level,i*25+16,5);
        setField(level,i*25+23,3);
        setField(level,i*25+24,5);
	}

    set_player(&level->player,0,22,15,15);  
}

static void getLevel36(Level* level)
{
    gint i,j;

    
    level->level=L36;

	level->max=12; 
    set_map(&level->map,35,19);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<9;i++){
    	for(j=0;j<9;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=0;i<35;i++){
    	setField(level,9*35+i,1);
		if(i>15 && i<19){
			setField(level,i*35+0,3);
			setField(level,i*35+1,5);
		}
    }

	setField(level,7*35+28,46);
	setField(level,8*35+30,46);
	setField(level,10*35+4,46);

    setField(level,7*35+33,24);
	setParx(level,7*35+33,32);
	setPary(level,7*35+33,7);
    setField(level,7*35+32,10);

    setField(level,8*35+34,24);
	setParx(level,8*35+34,32);
	setPary(level,8*35+34,8);
    setField(level,8*35+32,10);
    setField(level,8*35+33,12);

    setField(level,10*35+0,22);
	setParx(level,10*35+0,2);
	setPary(level,10*35+0,10);
    setField(level,10*35+2,8);
    setField(level,10*35+1,12);

    set_player(&level->player,29,5,10,10);  
}

static void getLevel37(Level* level)
{
    gint i,j;

    
    level->level=L37;

	level->max=18; 
    set_map(&level->map,31,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<31;i++){
    	for(j=0;j<15;j++){
			if(i>1 && j>12)alloc_balaban(i,j,1,&level->balabans);
			if(i>1 && j==12)setField(level,j*31+i,1);
            if(i==1 && j<14)setField(level,j*31+i,2);
		}
		if(i>8 && i<15)	alloc_balaban(0,i,4,&level->balabans);
		if(i>1 && i<9){
   			setField(level,i*31+0,22);
			setParx(level,i*31+0,2);
			setPary(level,i*31+0,i);
		    setField(level,i*31+2,8);
			setField(level,0*31+i,3);
		}
	}
	alloc_balaban(0,0,4,&level->balabans);
	alloc_balaban(0,1,4,&level->balabans);

    setField(level,14*31+1,1);
	setField(level,1*31+18,46);

    set_player(&level->player,29,1,5,5);  
}

static void getLevel38(Level* level)
{
    gint i,j;

    
    level->level=L38;

	level->max=33; 
    set_map(&level->map,31,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<31;i++){
    	for(j=0;j<15;j++){
			if(i>1 && j>12)alloc_balaban(i,j,4,&level->balabans);
			if(i>1 && j==12)setField(level,j*31+i,(i>4)?2:1);
            if(i==1 && j<14)setField(level,j*31+i,2);
		}
		if(i>8 && i<15)	alloc_balaban(0,i,4,&level->balabans);
		if(i>1 && i<12){
   			setField(level,i*31+0,22);
			setParx(level,i*31+0,2);
			setPary(level,i*31+0,i);
		    setField(level,i*31+2,8);
			setField(level,0*31+i,3);
		}
	}
	alloc_balaban(0,0,4,&level->balabans);
	alloc_balaban(0,1,4,&level->balabans);

    setField(level,14*31+1,1);
	setField(level,1*31+18,46);
	setField(level,1*31+20,46);

    set_player(&level->player,29,1,5,5);  
}

static gboolean level39_end(Level* level)
{   
	if(level->map.field[15*37+6]!=0) return TRUE;

    return COUNT_END(level);
}

static void getLevel39(Level* level)
{
    gint i,j,k;

    
    level->level=L39;

	level->max=47; 
    set_map(&level->map,37,17);
    level->endFunc=level39_end;

    level->balabans=NULL;
    for(i=0;i<5;i++){
    	for(j=0;j<17;j++){
			alloc_balaban(i,j,4,&level->balabans);
			if(i==0) setField(level,j*37+5,1);
		}
	}
	for(i=6;i<17;i+=3){
   		setField(level,i*37+6,20);
		setParx(level,i*37+6,12);
	}
	for(k=0;k<5;k++){
    	for(i=0;i<4;i++){
    		for(j=0;j<4;j++){
				alloc_balaban(i+6+k*5,j,4,&level->balabans);
			}
			setField(level,i*37+10+k*5,1);
			setField(level,4*37+6+i+k*5,1);
		}
		setField(level,i*37+10+k*5,1);

		if(k>1){
	   		setField(level,5*37+6+k*5,1);
   			setField(level,6*37+6+k*5,20);
			setParx(level,6*37+6+k*5,k*2+1);
		}
   		setField(level,5*37+8+k*5,1);
   		setField(level,6*37+8+k*5,20);
		setParx(level,6*37+8+k*5,k*2+2);
	}

	setField(level,11*37+16,37);    
    setField(level,11*37+17,38);    
    setField(level,11*37+18,37);    
    setField(level,11*37+19,38);    
    setField(level,11*37+20,39);    
    setField(level,11*37+21,38);

    set_player(&level->player,18,8,100,100);  
}

static void getLevel40(Level* level)
{
    gint i,j;

    gint koule[19][2]={{0,7},{1,2},{1,6},{3,5},{4,7},{5,10},{6,8},{6,17},{7,6},{7,16},
					{8,12},{9,15},{10,13},{11,2},{11,14},{12,13},{13,6},{14,17},{15,18}
		};
    
    level->level=L40;

	level->max=19; 
    set_map(&level->map,34,16);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<16;i++){
		setField(level,i*34+0,((i%2)==0)?3:5);
        setField(level,i*34+32,(i==7 || i==9)?1:2);
    	for(j=28;j<31;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
	}
    for(i=0;i<19;i++) setField(level,koule[i][0]*34+koule[i][1],46);

    setField(level,2*34+33,24);
	setParx(level,2*34+33,31);
	setPary(level,2*34+33,2);
    setField(level,2*34+31,10);

    setField(level,8*34+33,24);
	setParx(level,8*34+33,31);
	setPary(level,8*34+33,8);
    setField(level,8*34+31,10);

    setField(level,13*34+33,24);
	setParx(level,13*34+33,31);
	setPary(level,13*34+33,13);
    setField(level,13*34+31,10);

    setField(level,7*34+31,6);
    setField(level,9*34+31,6);

	alloc_balaban(33,0,4,&level->balabans);
	alloc_balaban(33,1,4,&level->balabans);
	alloc_balaban(33,4,4,&level->balabans);
	alloc_balaban(33,5,4,&level->balabans);
	alloc_balaban(33,6,4,&level->balabans);
	alloc_balaban(33,10,4,&level->balabans);
	alloc_balaban(33,11,4,&level->balabans);
	alloc_balaban(33,14,4,&level->balabans);
	alloc_balaban(33,15,4,&level->balabans);

    set_player(&level->player,12,12,5,5);  
}

static void getLevel41(Level* level)
{
    gint i,j,k,l;

    
    level->level=L41;

	level->max=13; 
    set_map(&level->map,37,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<10;j++){
			alloc_balaban(j,i,4,&level->balabans);
			if(i<3 && j<3){
			    for(k=0;k<4;k++){
    				for(l=0;l<4;l++){
						gint pozx=13+9*i;
						gint pozy=((i==1)?3:6)+6*j;
                        if((k!=0 && k!=3) || l==1 || l==2){
							setField(level,(pozy+k)*37+pozx+l,25);    						
						}					
					}
				}
            }
		}
	}
	setField(level,12*37+15,37);    
    setField(level,12*37+16,38);    
    setField(level,12*37+17,37);    
    setField(level,12*37+18,38);    
    setField(level,12*37+19,39);    
    setField(level,12*37+20,38);
    set_player(&level->player,18,4,100,100);  
}

static void getLevel42(Level* level)
{
    gint i,j;

    
    level->level=L42;

	level->max=8; 
    set_map(&level->map,39,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;

    for(i=0;i<15;i++){
   		for(j=0;j<3;j++){
			alloc_balaban(j,i,4,&level->balabans);
			alloc_balaban(j+36,i,4,&level->balabans);
        }
        setField(level,i*39+3,1);
        setField(level,i*39+35,1);
        if((i%2)==1){
 	        setField(level,i*39+4,20);
        	setParx(level,i*39+4,1);
 	        setField(level,i*39+34,20);
        	setParx(level,i*39+34,1);
		}
		if((i%4)==3){
 	        setField(level,i*39+6,19);
 	        setField(level,i*39+45,13);
 	        setField(level,i*39+46,16);
 	        setField(level,i*39+7,14);
 	        setField(level,i*39+11,12);
 	        setField(level,i*39+15,12);
 	        setField(level,i*39-21,14);
			setField(level,i*39-20,24);
        	setParx(level,i*39-20,6);
        	setPary(level,i*39-20,i);

 	        setField(level,i*39+32,19);
 	        setField(level,i*39+71,16);
 	        setField(level,i*39+70,13);
 	        setField(level,i*39+31,15);
 	        setField(level,i*39+23,12);
 	        setField(level,i*39+27,12);
 	        setField(level,i*39+59,16);
			setField(level,i*39+58,22);
        	setParx(level,i*39+58,32);
        	setPary(level,i*39+58,i);
		}
    }
    for(i=0;i<15;i+=2){
        for(j=9;j<30;j+=4){
        	setField(level,i*39+j,2);
      	}
    }
    for(i=3;i<12;i+=4){
      	for(j=8;j<31;j++){
        	if((j%4)!=3) setField(level,i*39+j,2);
      	}
    }
    for(i=1;i<15;i+=4){
        for(j=13;j<26;j+=4){
        	alloc_balaban(j,i,1,&level->balabans);
      	}
    }
    for(i=1;i<15;i+=4){
        for(j=11;j<28;j+=4){
        	setField(level,i*39+j,44);
      	}
    }

    set_player(&level->player,10,1,200,200);  
}

static void getLevel43(Level* level)
{
    gint i,j;

    
    level->level=L43;

	level->max=13; 
    set_map(&level->map,39,18);
    level->endFunc=NOT_END;

    level->balabans=NULL;
	for(i=0;i<9;i++){
   		for(j=29;j<39;j++){
			alloc_balaban(j,i,4,&level->balabans);
        }
	}

    for(i=2;i<31;i++){
   		for(j=11;j<13;j++){
          setField(level,j*39+i,25);
        }
	}

    set_player(&level->player,29,10,200,200);  
}

static void getLevel44(Level* level)
{
    gint i,j;

    
    level->level=L44;

	level->max=35; 
    set_map(&level->map,36,13);
    level->endFunc=NOT_END;

    level->balabans=NULL;

    for(i=0;i<10;i++){
   		for(j=0;j<3;j++){
			alloc_balaban(j,i,4,&level->balabans);
        }
		for(j=30;j<36;j++){
			alloc_balaban(j,i,4,&level->balabans);
        }
		alloc_balaban(3,i,0,&level->balabans);
		alloc_balaban(29,i,0,&level->balabans);
        if((i%2)==1){
			setField(level,i*36+7,19);
			setField(level,i*36+43,13);
            setField(level,i*36+44,16);
            setField(level,i*36+8,14);
            for(j=9;j<16;j++){
				setField(level,i*36+j,12);
			}
			setField(level,i*36+16,24);
        	setParx(level,i*36+16,7);
        	setPary(level,i*36+16,i);
			setField(level,i*36+26,19);
			setField(level,i*36+62,16);
			setField(level,i*36+61,13);
			setField(level,i*36+25,15);
            for(j=18;j<25;j++){
				setField(level,i*36+j,12);
			}
			setField(level,i*36+17,22);
        	setParx(level,i*36+17,26);
        	setPary(level,i*36+17,i);
		}else{
			for(j=15;j<19;j++){
				setField(level,i*36+j,44);
			}
		}
	}
	for(i=0;i<36;i++){
	    setField(level,10*36+i,1);
		alloc_balaban(i,11,4,&level->balabans);
		alloc_balaban(i,12,4,&level->balabans);
	}
  
    set_player(&level->player,19,0,100,200);  
}

static void getLevel45(Level* level)
{
    gint i,j;

    
    level->level=L45;

	level->max=11; 
    set_map(&level->map,35,18);
    level->endFunc=NOT_END;

    level->balabans=NULL;

    for(i=0;i<5;i++){
   		for(j=0;j<18;j++){
			alloc_balaban(i,j,4,&level->balabans);
        }
	}
    for(i=7;i<28;i++){
		for(j=0;j<7;j++){
			setField(level,j*35+i,2);
		}
	}
    for(i=0;i<15;i+=7){
		for(j=0;j<9;j+=8){
			setField(level,(j+8)*35+i+8,35);
			setField(level,(j+8)*35+i+10,34);
        	setParx(level,(j+8)*35+i+10,i+8);
        	setPary(level,(j+8)*35+i+10,j+8);
			setField(level,(j+9)*35+i+10,21);
        	setParx(level,(j+9)*35+i+10,i+10);
        	setPary(level,(j+9)*35+i+10,j+8);

		}
	}
  
    set_player(&level->player,8,12,100,200);  
}

static void getLevel46(Level* level)
{
    gint i,j;

    
    level->level=L46;

	level->max=17; 
    set_map(&level->map,55,25);
    level->endFunc=NOT_END;

    level->balabans=NULL;

    for(i=0;i<10;i++){
   		for(j=15;j<25;j++){
			alloc_balaban(i,j,4,&level->balabans);
        }
	}

	setField(level,2*55+28,35);
	setField(level,2*55+30,34);
   	setParx(level,2*55+30,28);
   	setPary(level,2*55+30,2);
	setField(level,3*55+30,21);
   	setParx(level,3*55+30,30);
   	setPary(level,3*55+30,2);

	setField(level,22*55+28,35);
	setField(level,22*55+30,34);
   	setParx(level,22*55+30,28);
   	setPary(level,22*55+30,22);
	setField(level,23*55+30,21);
   	setParx(level,23*55+30,30);
   	setPary(level,23*55+30,22);

    set_player(&level->player,12,12,100,200);  
}

static gboolean level47_end(Level* level)
{	gint potrebaPocetNaboju=0;
	gint pocetCharge=0;
    if(level->map.field[7*25+16]==1)potrebaPocetNaboju++;
	if(level->map.field[3*25+18]==1)potrebaPocetNaboju++;
    if(level->map.field[6*25+22]==1)potrebaPocetNaboju++;
    if(level->map.field[1*25+24]==1)potrebaPocetNaboju++;
    if(potrebaPocetNaboju>COUNT_SHOTS(level)) return FALSE;
    if(level->map.field[8*25+16]==19)pocetCharge++;
	if(level->map.field[7*25+22]==19)pocetCharge++;
    return ( COUNT_END_POCET(level)+3*pocetCharge ) >= 0;
}

static void getLevel47(Level* level)
{
    gint i,j;

    
    level->level=L47;

	level->max=37; 
    set_map(&level->map,25,11);
    level->endFunc=level47_end;

    level->balabans=NULL;

    for(i=0;i<11;i++){
		if(i>1 && i<7)alloc_balaban(16,i,0,&level->balabans);
		if(i>1 && i<6)alloc_balaban(22,i,1,&level->balabans);
		if(i>3 && i<11)alloc_balaban(24,i,4,&level->balabans);
   		for(j=0;j<25;j++){
            if(j==0 && i==9){ setField(level,i*25+j,3); continue; }
            if(j==0 && i!=0){ continue; }
            if(j==1 && i>2  && i<7){ continue; }
            if(j==1 && i==10){ continue; }
            if(j>1 && j<12 && i==10){ continue; }
            if(j==5 && i==0){ setField(level,i*25+j,5); continue; }
            if(j>5 && j<8 && i==0){ setField(level,i*25+j,3); continue; }
            if(j>5 && j<8 && i==1){ setField(level,i*25+j,1); continue; }
            if(j==6 && i==2){ setField(level,i*25+j,1); continue; }
            if(j==7 && i==2){ continue; }
            if(j==6 && i==3){ continue; }
            if(j==7 && i==3){ setField(level,i*25+j,1); continue; }
            if(j>4 && j<8 && i>3 && i<8){ continue; }
            if(j==7 && i==9){ setField(level,i*25+j,1); continue; }
            if(j>7 && j<25 && i==0){ continue; }
            if(j==8 && i==2){ setField(level,i*25+j,1); continue; }
            if(j>8 && j<11 && i==2){ continue; }
            if(j==11 && i>1 && i<8){ continue; }
            if(j>7 && j<11 && i==7){ continue; }
            if(j==14 && i>0 && i<11){ continue; }
            if(j==7 && i==8){ continue; }
            if(j==15 && i==10){ continue; }
            if(j==16 && i==10){ continue; }
            if(j==16 && i==9){
				setField(level,i*25+j,21);
			   	setParx(level,i*25+j,j);
			   	setPary(level,i*25+j,i-1);
           		continue; 
			}
            if(j==16 && i==8){ setField(level,i*25+j,19); continue; }
            if(j==16 && i==7){ setField(level,i*25+j,1); continue; }
            if(j==16 && i>1 && i<7){ continue; }
            if(j==17 && i==2){ continue; }
            if(j==18 && i==2){ continue; }
            if(j==18 && i==3){ setField(level,i*25+j,1); continue; }
            if(j==18 && i>3 && i<10){ continue; }
            if(j==18 && i==10){ setField(level,i*25+j,5); continue; }
            if(j==20){ continue; }
            if(j==21 && i==10){ continue; }
            if(j==22 && i==10){ continue; }
            if(j==22 && i==9){
				setField(level,i*25+j,21);
			   	setParx(level,i*25+j,j);
			   	setPary(level,i*25+j,i-2);
           		continue; 
			}
            if(j==22 && i==8){ setField(level,i*25+j,11); continue; }
            if(j==22 && i==7){ setField(level,i*25+j,19); continue; }
            if(j==22 && i==6){ setField(level,i*25+j,1); continue; }
            if(j==22 && i>1 && i<6){ continue; }
            if(j==24 && i==1){ setField(level,i*25+j,1); continue; }
            if(j==24 && i>1 && i<11){ continue; }

      		setField(level,i*25+j,2);
        }
	}
	alloc_balaban(0,8,0,&level->balabans);
	alloc_balaban(7,2,4,&level->balabans);
	alloc_balaban(11,10,0,&level->balabans);
	alloc_balaban(17,2,0,&level->balabans);
	alloc_balaban(18,2,0,&level->balabans);

    set_player(&level->player,0,1,0,0);  
}

static void getLevel48(Level* level)
{
    gint i,j;

    
    level->level=L48;

	level->max=17; 
    set_map(&level->map,34,11);
    level->endFunc=COUNT_END;

    level->balabans=NULL;

    for(i=0;i<4;i++){
   		for(j=0;j<11;j++){
		   	alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=4;i<30;i++){
   		for(j=3;j<8;j++){
		   	setField(level,j*34+i,2);
		}
	}

	setField(level,5*34+14,37);    
    setField(level,5*34+15,38);    
    setField(level,5*34+16,37);    
    setField(level,5*34+17,38);    
    setField(level,5*34+18,39);    
    setField(level,5*34+19,38);

    set_player(&level->player,14,10,100,100);  
}

static void getLevel49(Level* level)
{
    gint i,j;

    
    level->level=L49;

	level->max=26; 
    set_map(&level->map,21,10);
    level->endFunc=NOT_END;

    level->balabans=NULL;

	alloc_balaban(0,3,3,&level->balabans);
	alloc_balaban(0,4,3,&level->balabans);
	alloc_balaban(0,5,3,&level->balabans);
	alloc_balaban(0,6,3,&level->balabans);
	alloc_balaban(0,7,3,&level->balabans);

    for(i=0;i<21;i++){
	   	alloc_balaban(i,9,4,&level->balabans);
		if(i<17)setField(level,8*21+i,2);
		else setField(level,8*21+i,1);
        if(i>0 && i<8){
			setField(level,i*21+4,2);
			setField(level,i*21+16,2);
		}
        if(i>4 && i<16){
			setField(level,7*21+i,(i%2)?((i%6==1)?3:5):2);
   			for(j=2;j<7;j++){ setField(level,j*21+i,1); }
		}
	}

    for(i=0;i<5;i+=2){
		setField(level,(2+i)*21+19,10);
		setField(level,(2+i)*21+20,15);
		setField(level,(3+i)*21+20,16);
		setField(level,(3+i)*21+19,12);
		setField(level,(3+i)*21+18,12);
		setField(level,(3+i)*21+17,22);
		setParx(level,(3+i)*21+17,19);
		setPary(level,(3+i)*21+17,(2+i));
	}

    set_player(&level->player,3,3,6,0);  
}

static void getLevel50(Level* level)
{
    gint i,j;

    
    level->level=L50;

	level->max=19; 
    set_map(&level->map,23,17);
    level->endFunc=COUNT_END;

    level->balabans=NULL;

    for(i=0;i<5;i++){
   		for(j=11;j<17;j++){
		   	alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=0;i<17;i++){
   		for(j=19;j<22;j++){
		   	if(i%2)setField(level,i*23+j,(j==20)?((i%6==5)?3:5):1);
            else setField(level,i*23+j,2);
		}
	}

	setField(level,6*23+11,37);    
    setField(level,7*23+11,38);    
    setField(level,8*23+11,37);    
    setField(level,9*23+11,38);    
    setField(level,10*23+11,39);    
    setField(level,11*23+11,38);

    set_player(&level->player,14,10,6,6);  
}

static void getLevel51(Level* level)
{
    gint i,j;
    
    level->level=L51;

	level->max=41; 
    set_map(&level->map,30,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<13;i++){
		alloc_balaban(29,i,4,&level->balabans);
		alloc_balaban(28,i,3,&level->balabans);
		for(j=10;j<20;j++){
			if((i*10+(j-10)+8)%14==0) setField(level,i*30+j,2);
			else setField(level,i*30+j,1);
		}
		setField(level,i*30+5,((i%2)==0)?3:5);
		if(i>1)setField(level,i*30+4,2);
		if((i%5)==0){
			setField(level,(i+3)*30+1,2);
			setField(level,(i+5)*30+2,2);
			setField(level,(i+3)*30,3);
			setField(level,(i+3)*30+3,5);
		}
	}
    for(i=14;i<20;i++){
		alloc_balaban(20,i,0,&level->balabans);
		alloc_balaban(21,i,3,&level->balabans);
		for(j=22;j<30;j++){
			alloc_balaban(j,i,1,&level->balabans);		
		}
		for(j=10;j<20;j++){
			setField(level,i*30+j,1);
		}
	}
	for(i=6;i<30;i++)setField(level,13*30+i,2);
	setField(level,13*30+5,23);
    setParx(level,13*30+5,18);
    setPary(level,13*30+5,14);
	setField(level,14*30+5,11);
	setField(level,15*30+5,13);
	setField(level,14*30+18,19);
	setField(level,15*30+18,16);
	for(i=6;i<18;i++)setField(level,15*30+i,12);
	setField(level,15*30+10,2);

	setField(level,1*30+7,2);
	setField(level,4*30+7,2);

	setField(level,7*30+23,2);
	
    set_player(&level->player,24,8,18,20);  
}

static void getLevel52(Level* level)
{
    gint i,j;
    
    level->level=L52;

	level->max=31; 
    set_map(&level->map,30,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=22;i<30;i++){
		for(j=17;j<25;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=0;i<30;i++){
		for(j=0;j<25;j++){
			if((i*25+j)%86==0)setField(level,j*30+i,3);
			if((i*25+j)%53==15)setField(level,j*30+i,5);
			if((i*25+j)%181==20)setField(level,j*30+i,45);
			if((i*25+j)%211==10)setField(level,j*30+i,44);
		}
	}

    setField(level,23*30+12,5);
	setField(level,22*30+11,44);
    setField(level,5*30+5,44);
    setField(level,5*30+9,44);
    setField(level,5*30+28,44);
    setField(level,8*30+28,44);
    setField(level,11*30+26,44);
    setField(level,14*30+26,44);
	setField(level,11*30+27,5);

    set_player(&level->player,13,24,50,0);  
}

static void getLevel53(Level* level)
{
    gint i,j;
    level->level=L53;

	level->max=23; 
    set_map(&level->map,55,35);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<35;i++){
		for(j=0;j<1;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
        for(j=54;j<55;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=10;i<23;i++){
        setField(level,i*55+16,6);
        setField(level,i*55+38,6);
    }
    setField(level,15*55+18,44);
    setField(level,15*55+21,44);
    setField(level,15*55+24,44);
    set_player(&level->player,30,0,200,200);  
}

static gboolean level54_end(Level* level)
{
	if(level->map.field[9*55+16]==0 && level->map.field[9*55+38]==0) COUNT_END(level);
    return TRUE;
}

static void getLevel54(Level* level)
{
    gint i,j;
    
    level->level=L54;

	level->max=35; 
    set_map(&level->map,55,35);
    level->endFunc=level54_end;

    level->balabans=NULL;
    for(i=0;i<35;i++){
		for(j=0;j<2;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
        if((i%3)==1)setField(level,i*55+28,44);
        for(j=53;j<55;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=9;i<24;i++){
        setField(level,i*55+16,6);
        setField(level,i*55+38,6);
    }
    setField(level,33*55+31,44);
    setField(level,33*55+33,44);
    setField(level,34*55+25,44);
    setField(level,34*55+21,44);
    setField(level,3*55+25,44);
    set_player(&level->player,30,1,200,200);  
}

static gboolean level55_end(Level* level)
{
	if(level->map.field[1*40+28]!=0) COUNT_END(level);
    return TRUE;
}

static void getLevel55(Level* level)
{
    gint i,j;
    gint vybuch=36;
    
    level->level=L55;

	level->max=71; 
    set_map(&level->map,40,23);
    level->endFunc=level55_end;

    level->balabans=NULL;
    for(i=0;i<15;i++){
		for(j=0;j<3;j++){
			alloc_balaban(i,j,1,&level->balabans);
		}
        for(j=6;j<10;j++){
			alloc_balaban(i,j,2,&level->balabans);
		}
        for(j=13;j<17;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

    for(i=0;i<36;i++){
        if(i<16 || i>23)setField(level,18*40+i,1);
        else setField(level,18*40+i,43);
        if(i<6){
			setField(level,19*40+1+3*i,20);
			setParx(level,19*40+1+3*i,vybuch);
        }
        if(i<28)setField(level,4*40+i,1);
        if(i<22)setField(level,11*40+i,1);
        if(i>29)setField(level,4*40+i,43);
        if(i>25)setField(level,11*40+i,43);
        if(i>18 && i<25)setField(level,17*40+i,3);
        if(i<4)setField(level,i*40+27,1);
        if(i<5)setField(level,i*40+35,1);
        if(i>4 && i<19)setField(level,i*40+35,43);
        if(i>4 && i<11)setField(level,i*40+21,1);
        if(i>11 && i<18)setField(level,i*40+18,1);
        if(i>11 && i<18)setField(level,i*40+17,3);
        if(i>11 && i<18)setField(level,i*40+16,5);
        for(j=21;j<24;j++){
        	if(i<4)setField(level,i*40+j,5);
        	if(i<4)setField(level,i*40+j+3,3);
		}
		for(j=17;j<19;j++){
        	if(i>4 && i<11)setField(level,i*40+j,5);
        	if(i>4 && i<11)setField(level,i*40+j+2,3);
		}
    }
	setField(level,1*40+28,20);
	setParx(level,1*40+28,vybuch);
	setField(level,3*40+4,20);
	setParx(level,3*40+4,vybuch);
	setField(level,3*40+10,20);
	setParx(level,3*40+10,vybuch);
	setField(level,5*40+1,20);
	setParx(level,5*40+1,vybuch);
	setField(level,5*40+7,20);
	setParx(level,5*40+7,vybuch);
	setField(level,5*40+13,20);
	setParx(level,5*40+13,vybuch);
	setField(level,5*40+22,20);
	setParx(level,5*40+22,vybuch);
	setField(level,5*40+25,20);
	setParx(level,5*40+25,vybuch);
	setField(level,8*40+22,20);
	setParx(level,8*40+22,vybuch);
	setField(level,10*40+4,20);
	setParx(level,10*40+4,vybuch);
	setField(level,10*40+10,20);
	setParx(level,10*40+10,vybuch);
	setField(level,12*40+1,20);
	setParx(level,12*40+1,vybuch);
	setField(level,12*40+7,20);
	setParx(level,12*40+7,vybuch);
	setField(level,12*40+19,20);
	setParx(level,12*40+19,vybuch);
	setField(level,15*40+19,20);
	setParx(level,15*40+19,vybuch);

    set_player(&level->player,10,21,35,10);  
}

static void getLevel56(Level* level)
{
    gint i,j;
    gint vybuch=40;
    
    level->level=L56;

	level->max=82; 
    set_map(&level->map,40,23);
    level->endFunc=level55_end;

    level->balabans=NULL;
    for(i=0;i<15;i++){
		for(j=0;j<3;j++){
			alloc_balaban(i,j,1,&level->balabans);
		}
        for(j=6;j<10;j++){
			alloc_balaban(i,j,2,&level->balabans);
		}
        for(j=13;j<17;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

    for(i=0;i<36;i++){
        if(i<16)setField(level,18*40+i,1);
        else setField(level,18*40+i,43);
        if(i<6){
			setField(level,19*40+1+3*i,20);
			setParx(level,19*40+1+3*i,vybuch);
        }
        if(i<28)setField(level,4*40+i,1);
        if(i<22)setField(level,11*40+i,1);
        if(i>29)setField(level,4*40+i,43);
        if(i>25)setField(level,11*40+i,43);
        if(i>18 && i<25)setField(level,17*40+i,3);
        if(i<4)setField(level,i*40+27,1);
        if(i<5)setField(level,i*40+35,1);
        if(i>4 && i<19)setField(level,i*40+35,43);
        if(i>4 && i<11)setField(level,i*40+21,1);
        if(i>11 && i<18)setField(level,i*40+18,1);
        if(i>11 && i<18)setField(level,i*40+17,3);
        if(i>11 && i<18)setField(level,i*40+16,5);
        for(j=21;j<24;j++){
        	if(i<4)setField(level,i*40+j,5);
        	if(i<4)setField(level,i*40+j+3,3);
		}
		for(j=17;j<19;j++){
        	if(i>4 && i<11)setField(level,i*40+j,5);
        	if(i>4 && i<11)setField(level,i*40+j+2,3);
		}
    }
	setField(level,1*40+28,20);
	setParx(level,1*40+28,vybuch);
	setField(level,3*40+4,20);
	setParx(level,3*40+4,vybuch);
	setField(level,3*40+10,20);
	setParx(level,3*40+10,vybuch);
	setField(level,5*40+1,20);
	setParx(level,5*40+1,vybuch);
	setField(level,5*40+7,20);
	setParx(level,5*40+7,vybuch);
	setField(level,5*40+13,20);
	setParx(level,5*40+13,vybuch);
	setField(level,5*40+22,20);
	setParx(level,5*40+22,vybuch);
	setField(level,5*40+25,20);
	setParx(level,5*40+25,vybuch);
	setField(level,8*40+22,20);
	setParx(level,8*40+22,vybuch);
	setField(level,10*40+4,20);
	setParx(level,10*40+4,vybuch);
	setField(level,10*40+10,20);
	setParx(level,10*40+10,vybuch);
	setField(level,12*40+1,20);
	setParx(level,12*40+1,vybuch);
	setField(level,12*40+7,20);
	setParx(level,12*40+7,vybuch);
	setField(level,12*40+19,20);
	setParx(level,12*40+19,vybuch);
	setField(level,15*40+19,20);
	setParx(level,15*40+19,vybuch);

    set_player(&level->player,10,21,35,10);  
}

static void getLevel57(Level* level)
{
    gint i,j;
    
    level->level=L57;

	level->max=23; 
    set_map(&level->map,55,35);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<5;i++){
		for(j=0;j<5;j++){
			alloc_balaban(j+2,i,4,&level->balabans);
			alloc_balaban(j+48,i,4,&level->balabans);
			alloc_balaban(j+2,i+30,4,&level->balabans);
			alloc_balaban(j+48,i+30,4,&level->balabans);
		}
        setField(level,i*2*55+0,44);
		setField(level,i*2*55+54,44);
        setField(level,(i*2+25)*55+0,44);
		setField(level,(i*2+25)*55+54,44);
        setField(level,(i*2+1)*55+0,44);
		setField(level,(i*2+1)*55+54,44);
        setField(level,(i*2+26)*55+0,44);
		setField(level,(i*2+26)*55+54,44);
	}
 
    setField(level,15*55+25,17);
    setParx(level,15*55+25,1);
    setPary(level,15*55+25,1);
    setField(level,1*55+1,18);
    setParx(level,1*55+1,1);

    setField(level,15*55+30,17);
    setParx(level,15*55+30,53);
    setPary(level,15*55+30,1);
    setField(level,1*55+53,18);
    setParx(level,1*55+53,2);

    setField(level,20*55+25,17);
    setParx(level,20*55+25,1);
    setPary(level,20*55+25,33);
    setField(level,33*55+1,18);
    setParx(level,33*55+1,3);

    setField(level,20*55+30,17);
    setParx(level,20*55+30,53);
    setPary(level,20*55+30,33);
    setField(level,33*55+53,18);
    setParx(level,33*55+53,4);
 
    set_player(&level->player,30,1,200,200);  
}

static void getLevel58(Level* level)
{
    gint i,j;
    
    level->level=L58;

	level->max=39; 
    set_map(&level->map,50,30);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<30;i++){
    	for(j=0;j<6;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
	}
    for(i=0;i<10;i++){
    	setField(level,i*3*50+24,6);
        setField(level,i*3*50+70,6);
        setField(level,i*3*50+78,6);
        setField(level,i*3*50+116,6);
        setField(level,i*3*50+132,6);
        setField(level,i*3*50+36,6);
        setField(level,i*3*50+90,6);
        setField(level,i*3*50+144,6);
		setField(level,i*3*50+48,6);
    }

    set_player(&level->player,24,14,250,0);  
}

static void getLevel59(Level* level)
{
    gint i,j,k,l;
    
    level->level=L59;

	level->max=16; 
    set_map(&level->map,40,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<11;i++){
    	for(j=0;j<11;j++){
			alloc_balaban(j,i,4,&level->balabans);
			if(i<3 && j<3){
			    for(k=0;k<4;k++){
    				for(l=0;l<4;l++){
						gint pozx=13+9*i;
						gint pozy=((i==1)?3:6)+6*j;
                        if((k!=0 && k!=3) || l==1 || l==2){
							setField(level,(pozy+k)*40+pozx+l,25);    						
						}					
					}
				}
            }
		}
	}
	setField(level,12*40+17,37);    
    setField(level,12*40+18,38);    
    setField(level,12*40+19,37);    
    setField(level,12*40+20,38);    
    setField(level,12*40+21,39);    
    setField(level,12*40+22,38);
    set_player(&level->player,18,4,100,100);  
}

static void getLevel60(Level* level)
{
    gint i,j;
    
    level->level=L60;

	level->max=25; 
    set_map(&level->map,41,20);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<20;i++){
    	for(j=0;j<4;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
		for(j=4;j<8;j++){
			setField(level,i*41+j,1);
		}
		for(j=19;j<23;j++){
			setField(level,i*41+j,1);
		}
		for(j=33;j<37;j++){
			setField(level,i*41+j,1);
		}
        if(i%4==2) setField(level,i*41+5,6); 
        if(i%4==1) setField(level,i*41+6,6); 
        if(i%4==3) setField(level,i*41+7,6); 
        if(i%4==2) setField(level,i*41+20,6); 
        if(i%4==3) setField(level,i*41+21,6); 
        if(i%4==1) setField(level,i*41+22,6); 
        if(i%4==2) setField(level,i*41+34,6); 
        if(i%4==1) setField(level,i*41+35,6); 
        if(i%4==3) setField(level,i*41+36,6); 

	}
    setField(level,1*41+12,44);
	setField(level,1*41+13,3);
	setField(level,1*41+14,3);
	setField(level,1*41+15,44);
	setField(level,1*41+26,44);
	setField(level,1*41+27,3);
	setField(level,1*41+28,3);
	setField(level,1*41+29,44);
	setField(level,1*41+37,44);
	setField(level,1*41+38,5);
	setField(level,1*41+39,5);
	setField(level,1*41+40,44);

	setField(level,18*41+12,44);
	setField(level,18*41+13,3);
	setField(level,18*41+14,3);
	setField(level,18*41+15,44);
	setField(level,18*41+26,44);
	setField(level,18*41+27,3);
	setField(level,18*41+28,3);
	setField(level,18*41+29,44);
	setField(level,18*41+37,44);
	setField(level,18*41+38,3);
	setField(level,18*41+39,3);
	setField(level,18*41+40,44);

    set_player(&level->player,10,10,30,30);  
}

static void getLevel61(Level* level)
{
    gint i,j;
    
    level->level=L61;

	level->max=37; 
    set_map(&level->map,23,13);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<23;i++){
    	for(j=0;j<3;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
		setField(level,3*23+i,1);
		setField(level,4*23+i,(i%2==1)?6:1);
		setField(level,8*23+i,(i%2==1)?6:1);
		setField(level,9*23+i,1);
	}
	setField(level,11*23+1,3);
	setField(level,11*23+11,3);
	setField(level,11*23+21,3);

	setField(level,6*23+1,6);
	setField(level,6*23+3,6);
	setField(level,6*23+21,6);
	setField(level,6*23+19,6);

	setField(level,6*23+9,37);    
    setField(level,6*23+10,38);    
    setField(level,6*23+11,37);    
    setField(level,6*23+12,38);    
    setField(level,6*23+13,39);    
    setField(level,6*23+14,38);

    set_player(&level->player,11,6,30,40);  
}

static void getLevel62(Level* level)
{
    gint i,j;
    
    level->level=L62;

	level->max=17; 
    set_map(&level->map,17,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<15;i++){
    	for(j=0;j<3;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
		setField(level,i*17+3,43);
	}
    for(i=0;i<3;i++){
    	for(j=0;j<2;j++){
			alloc_balaban(j+4,i,1,&level->balabans);
		}
		setField(level,i*17+6,2);
		setField(level,(i+12)*17+6,2);
	}


	setField(level,7*17+1,35);
	setField(level,7*17+11,34);
    setParx(level,7*17+11,1);
    setPary(level,7*17+11,7);
	setField(level,8*17+11,16);
	setField(level,8*17+10,12);
	setField(level,8*17+9,22);
    setParx(level,8*17+9,11);
    setPary(level,8*17+9,7);


    set_player(&level->player,7,2,20,10);  
}

static void getLevel63(Level* level)
{
    gint i,j;
    
    level->level=L63;

	level->max=15; 
    set_map(&level->map,27,16);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<16;i++){
    	for(j=0;j<2;j++){
			alloc_balaban(j,i,3,&level->balabans);
		}
		setField(level,i*27+2,43);
	}
    for(i=0;i<6;i++){
    	for(j=22;j<26;j++){
			alloc_balaban(j,i,0,&level->balabans);
		}
		setField(level,i*27+26,3);
	}
    for(i=5;i<21;i+=5){
    	for(j=2;j<13;j+=5){
  			setField(level,j*27+i,2);
		}
	}

	setField(level,5*27+1,35);
	setField(level,5*27+13,34);
    setParx(level,5*27+13,1);
    setPary(level,5*27+13,5);
	setField(level,6*27+13,16);
	setField(level,6*27+12,22);
    setParx(level,6*27+12,13);
    setPary(level,6*27+12,5);

	setField(level,9*27+1,35);
	setField(level,9*27+13,34);
    setParx(level,9*27+13,1);
    setPary(level,9*27+13,9);
	setField(level,10*27+13,16);
	setField(level,10*27+12,22);
    setParx(level,10*27+12,13);
    setPary(level,10*27+12,9);

    set_player(&level->player,12,7,5,5);  
}

static void getLevel64(Level* level)
{
    gint i,j;
    
    level->level=L64;

	level->max=8; 
    set_map(&level->map,27,18);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=14;j<18;j++){
			alloc_balaban(i,j,(i==0)?1:4,&level->balabans);
			alloc_balaban(i+21,j,(i==5)?1:4,&level->balabans);
		}
	}
    for(i=0;i<13;i+=2){
		setField(level,i*27+26,24);
   		setParx(level,i*27+26,25);
	    setPary(level,i*27+26,i);
		setField(level,i*27+25,10);
		setField(level,(i+1)*27+0,22);
   		setParx(level,(i+1)*27+0,1);
	    setPary(level,(i+1)*27+0,i+1);
		setField(level,(i+1)*27+1,8);
	}
    set_player(&level->player,14,8,100,100);  
}

static void getLevel65(Level* level)
{
    gint i,j;
    
    level->level=L65;

	level->max=28; 
    set_map(&level->map,25,20);
    level->endFunc=COUNT_END_1_FUEL;

    level->balabans=NULL;
    for(i=0;i<5;i++){
    	for(j=0;j<20;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=0;i<20;i+=2){
		setField(level,i*25+5,1);
		setField(level,i*25+30,6);
		setField(level,i*25+10,1);
		setField(level,i*25+35,6);
		setField(level,i*25+15,1);
		setField(level,i*25+40,6);
		setField(level,i*25+20,1);
		setField(level,i*25+45,6);
	}
    set_player(&level->player,8,9,100,40);  
}

static void getLevel66(Level* level)
{
    gint i,j;
    
    level->level=L66;

	level->max=18; 
    set_map(&level->map,36,19);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<3;i++){
    	for(j=0;j<19;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=3;i<6;i++){
    	for(j=0;j<19;j++){
			if(i==4 && (j%2)==1)setField(level,j*36+i,6);
	  		else setField(level,j*36+i,1);
 		}
	}
	setField(level,13*36+14,46);
	setField(level,14*36+13,46);
	setField(level,15*36+14,46);
    for(i=0;i<3;i++){
		setField(level,(i+13)*36+15,22);
   		setParx(level,(i+13)*36+15,16);
	    setPary(level,(i+13)*36+15,13+i);
		setField(level,(i+13)*36+16,8);
	}
    set_player(&level->player,16,9,30,30);  
}

static void getLevel67(Level* level)
{
    gint i,j;
    
    level->level=L67;

	level->max=9; 
    set_map(&level->map,30,19);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=9;i<19;i++){
    	for(j=0;j<7;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=0;i<17;i+=4){
		setField(level,(2+i)*30+6+i,22);
	    setParx(level,(2+i)*30+6+i,7+i);
	    setPary(level,(2+i)*30+6+i,1+i);
		setField(level,(2+i)*30+7+i,16);
		setField(level,(1+i)*30+7+i,33);
	    setParx(level,(1+i)*30+7+i,9+i);
	    setPary(level,(1+i)*30+7+i,1+i);
		setField(level,(1+i)*30+9+i,35);
	}

    set_player(&level->player,9,9,100,100);  
}

static void getLevel68(Level* level)
{
    gint i,j;
    
    level->level=L68;

	level->max=27; 
    set_map(&level->map,50,35);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<10;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=10;i<47;i+=3){
    	for(j=0;j<35;j+=2){
 			if(i%2==1)setField(level,j*50+i,43);
 			else if(j<34)setField(level,j*50+50+i,43);
        }
	}

    set_player(&level->player,12,17,200,200);  
}

static void getLevel69(Level* level)
{
    gint i,j;
    
    level->level=L69;

	level->max=33; 
    set_map(&level->map,50,35);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<10;i++){
    	for(j=0;j<10;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=10;i<48;i+=2){
    	for(j=0;j<35;j+=2){
 			if(i%4==0)setField(level,j*50+i,45);
 			else if(j<34)setField(level,j*50+50+i,45);
        }
	}

    set_player(&level->player,12,17,200,200);  
}

static void getLevel70(Level* level)
{
    gint i,j;
    
    level->level=L70;

	level->max=14; 
    set_map(&level->map,38,13);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<13;i++){
    	for(j=0;j<5;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
        setField(level,i*38+5,1);
        setField(level,i*38+6,6);
        setField(level,i*38+7,1);
	}
    for(i=15;i<28;i++){
    	for(j=0;j<13;j++){
            gboolean isFuel=FALSE;
 			if(i==15 && (j<5 || j%2==0)) isFuel=TRUE;
 			if(i==16 && j>3 && (j%2==0 || j==7))isFuel=TRUE;
 			if(i==17 && (j==4 || j==10 || j==12))isFuel=TRUE;
 			if(i==18 && j!=5 && j!=11)isFuel=TRUE;
 			if(i==19 && (j==6 || j==12))isFuel=TRUE;
 			if(i==20 && j>1 && j!=5 && j!=7)isFuel=TRUE;
 			if(i==21 && j>0 && j!=3 && j!=7 && j<9)isFuel=TRUE;
 			if(i==22 && (j==1 || j==8))isFuel=TRUE;
 			if(i==23 && j>0 && j!=2 && j!=3 && j<9)isFuel=TRUE;
 			if(i==24 && j==1)isFuel=TRUE;
 			if(i==25 && j!=0 && j!=12)isFuel=TRUE;
 			if(i==27 && j!=6 && j!=0 && j!=12)isFuel=TRUE;

 			setField(level,j*38+i,isFuel?6:1);
        }
	}

	setField(level,5*38+30,6);
	setField(level,6*38+30,6);
	setField(level,7*38+30,6);

	setField(level,6*38+32,5);
	setField(level,6*38+33,5);

    set_player(&level->player,13,5,25,15);  
}

static void getLevel71(Level* level)
{
    gint i,j;
    
    level->level=L71;

	level->max=23; 
    set_map(&level->map,38,15);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<15;i++){
    	for(j=0;j<7;j++){
			alloc_balaban(j,i,2,&level->balabans);
		}
    	for(j=7;j<12;j++){
            if(((j==8 || j==10) && i!=4 && i!=7 && i!=10) ||
               (j==9 && (i==3 || i==6 || i==8 || i==11))) 
				setField(level,i*38+j,6);
       		else
				setField(level,i*38+j,1);
		}
    	for(j=20;j<25;j++){
        	if(j+i==24 || j+i==27 || j-i==13 || j-i==10)
 		        setField(level,i*38+j,6);
       		else
				setField(level,i*38+j,1);
		}
    	for(j=25;j<29;j++){
        	if(j+i==35 || j+i==38 || j-i==24 || j-i==21)
 		        setField(level,i*38+j,6);
       		else
				setField(level,i*38+j,1);
		}

	}

	setField(level,7*38+9,35);
    setField(level,7*38+15,34);
	setParx(level,7*38+15,9);
    setPary(level,7*38+15,7);
    setField(level,8*38+15,13);
    setField(level,8*38+16,12);
    setField(level,8*38+17,16);

	setField(level,7*38+17,23);
	setParx(level,7*38+17,15);
    setPary(level,7*38+17,7);

	setField(level,7*38+24,35);
    setField(level,7*38+32,34);
	setParx(level,7*38+32,24);
    setPary(level,7*38+32,7);
    setField(level,8*38+32,13);
    setField(level,8*38+33,12);
    setField(level,8*38+34,16);

	setField(level,7*38+34,23);
	setParx(level,7*38+34,32);
    setPary(level,7*38+34,7);

    set_player(&level->player,15,5,30,30);  
}

static gboolean level72_end(Level* level)
{
	if(level->map.field[0*27+7]==0 && level->map.field[8*27+7]==0 && level->map.field[1*27+17]==0 && 
		level->map.field[7*27+17]==0 && level->map.field[10*27+17]==0 && level->map.field[12*27+16]==0) return COUNT_END(level);
    return TRUE;
}

static void getLevel72(Level* level)
{
    gint i,j;
    
    level->level=L72;

	level->max=12; 
    set_map(&level->map,27,15);
    level->endFunc=level72_end;

    level->balabans=NULL;
    for(i=0;i<15;i++){
    	for(j=0;j<4;j++){
			alloc_balaban(j,i,4,&level->balabans);
		}
        if(i==3 || i==6 || i==8 || i==11) 
			setField(level,i*27+4,6);
		else
			setField(level,i*27+4,1);
        if(i==2 || i==4 || i==6 || i==8 || i==10 || i==12) 
			setField(level,i*27+5,6);
		else
			setField(level,i*27+5,1);
        if(i==1 || i==5 || i==9 || i==13) 
			setField(level,i*27+6,6);
		else
			setField(level,i*27+6,1);
        if(i==0 || i==6 || i==8 || i==14) 
			setField(level,i*27+7,6);
		else
			setField(level,i*27+7,1);

        if(i==7 || i==9 || i>11) 
			setField(level,i*27+16,6);
		else
			setField(level,i*27+16,1);
        if(i==1 || i==3 || i==4 || i==5 || i==7 || i==10) 
			setField(level,i*27+17,6);
		else
			setField(level,i*27+17,1);
        if(i==0 || i==4 || i==6 || i==8 || i==10 || i==13) 
			setField(level,i*27+18,1);
		else
			setField(level,i*27+18,6);
        if(i==5 || i==7 || i==10 || i==13) 
			setField(level,i*27+19,6);
		else
			setField(level,i*27+19,1);
	}
    set_player(&level->player,12,7,35,30);  
}

static void getLevel73(Level* level)
{
    gint i,j;
    
    level->level=L73;

	level->max=15; 
    set_map(&level->map,33,14);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<14;i++){
    	for(j=0;j<6;j++){
			if(i>8 || i<5)alloc_balaban(j,i,4,&level->balabans);
		}
	}
    for(i=6;i<26;i++){
    	for(j=0;j<14;j++){
            gboolean isFuel=FALSE;
 			if(i==6 && (j==0 || j==3 || j==6)) isFuel=TRUE;
 			if(i==7 && (j==0 || j==4 || j==6)) isFuel=TRUE;
 			if(i==8 && (j==1 || j==3 || j==6 || j==9 || j==10)) isFuel=TRUE;
 			if(i==9 && (j==2 || j==6 || j==9 || j==11 || j==13)) isFuel=TRUE;
 			if(i==10 && (j==2 || j==4 || j==5 || j==6 || j==9 || j==13)) isFuel=TRUE;
 			if(i==11 && (j==2 || j==11 || j==13)) isFuel=TRUE;
 			if(i==12 && (j==2 || (j>3 && j<10) || j==11 || j==13))isFuel=TRUE;
 			if(i==13 && (j==0 || j==2 || j==11 || j==13)) isFuel=TRUE;
 			if(i==14 && (j==0 || (j>1 && j<11) || j==13))isFuel=TRUE;
 			if(i==15 && (j==1 || j==13)) isFuel=TRUE;
 			if(i==16 && (j==1 || j==3 || (j>4 && j<10) || j==13))isFuel=TRUE;
			if(i==17 && (j==1 || j==3 || j==13)) isFuel=TRUE;
			if(i>17 && (j==1 || j==3 || j==5 || j==7 || j==9 || j==11)) isFuel=TRUE;
 			setField(level,j*33+i,isFuel?6:1);
        }
	}

	setField(level,3*33+28,3);
	setField(level,7*33+28,3);
	setField(level,11*33+28,3);

	setField(level,6*33+4,44);
	setField(level,6*33+5,44);

    set_player(&level->player,4,7,30,15);  
}

static gboolean level74_end(Level* level)
{
	if(level->map.field[1*20+4]==0 && level->map.field[11*20+5]==0) return COUNT_END(level);
    return TRUE;
}

static void getLevel74(Level* level)
{
    gint i,j;
    
    level->level=L74;

	level->max=7; 
    set_map(&level->map,20,15);
    level->endFunc=level74_end;

    level->balabans=NULL;
    for(i=14;i<20;i++){
    	for(j=0;j<8;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=4;i<9;i++){
      	setField(level,5*20+i,6);
        setField(level,7*20+i,6);
	}

	setField(level,4*20+3,6);
	setField(level,3*20+4,6);
	setField(level,2*20+5,6);
	setField(level,1*20+6,6);
	setField(level,2*20+7,6);
	setField(level,3*20+8,6);
	setField(level,4*20+9,6);

	setField(level,2*20+4,21);
	setField(level,1*20+4,19);
 	setParx(level,2*20+4,4);
 	setPary(level,2*20+4,1);

	setField(level,8*20+3,6);
	setField(level,9*20+4,6);
	setField(level,10*20+5,6);
	setField(level,11*20+6,6);
	setField(level,10*20+7,6);
	setField(level,9*20+8,6);
	setField(level,8*20+9,6);

	setField(level,12*20+5,21);
	setField(level,11*20+5,19);
 	setParx(level,12*20+5,5);
 	setPary(level,12*20+5,11);

    set_player(&level->player,10,6,0,100);  
}

static gboolean level75_end(Level* level)
{
	if(COUNT_SHOTS(level)<1 || (level->map.field[0*20+6]==0 && level->map.field[0*20+9]==0 && 
		level->map.field[2*20+5]==0 && level->map.field[5*20+6]==0 && 
        level->map.field[8*20+6]==0)) return COUNT_END(level);
    return TRUE;
}

static void getLevel75(Level* level)
{
    gint i,j;
    
    level->level=L75;

	level->max=14; 
    set_map(&level->map,26,11);
    level->endFunc=level75_end;

    level->balabans=NULL;
    for(i=0;i<5;i++){
    	for(j=0;j<11;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=5;i<10;i++){
		for(j=0;j<11;j++){
      		if((9+j-i)%3==0)setField(level,j*26+i,6);
			else setField(level,j*26+i,1);
		}
	}

    set_player(&level->player,13,5,40,20);  
}

static gboolean level76_end(Level* level)
{
	if(level->map.field[3*33+12]==0 && level->map.field[10*33+12]==0&& level->map.field[17*33+12]==0 &&
		level->map.field[3*33+19]==0 && level->map.field[10*33+19]==0&& level->map.field[17*33+19]==0 &&
		level->map.field[3*33+26]==0 && level->map.field[10*33+26]==0&& level->map.field[17*33+26]==0
    	) return COUNT_END(level);
    return TRUE;
}

static void getLevel76(Level* level)
{
    gint i,j;
    
    level->level=L76;

	level->max=13; 
    set_map(&level->map,33,21);
    level->endFunc=level76_end;

    level->balabans=NULL;
    for(i=0;i<8;i++){
    	for(j=0;j<14;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=12;i<27;i+=7){
		for(j=3;j<18;j+=7){
      		setField(level,j*33+i,6);
      		setField(level,(j+1)*33+i+1,6);
      		setField(level,(j+2)*33+i+2,6);
      		setField(level,(j+1)*33+i+3,6);
      		setField(level,j*33+i+4,6);
      		setField(level,(j-1)*33+i+3,6);
      		setField(level,(j-2)*33+i+2,6);
      		setField(level,(j-1)*33+i+1,6);

			setField(level,j*33+i+5,21);
			setField(level,(j-1)*33+i+5,19);
		 	setParx(level,j*33+i+5,i+5);
		 	setPary(level,j*33+i+5,j-1);
		}
	}

    set_player(&level->player,13,6,0,100);  
}

static void getLevel77(Level* level)
{
    gint i,j;
    
    level->level=L77;

	level->max=13; 
    set_map(&level->map,30,13);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<4;i++){
    	for(j=0;j<13;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=4;i<26;i++){
		for(j=0;j<5;j++) setField(level,j*30+i,2);
		for(j=8;j<13;j++) setField(level,j*30+i,2);
	}
    setField(level,6*30+8,44);
	setField(level,6*30+21,44);	

	setField(level,6*30+12,37);    
    setField(level,6*30+13,38);    
    setField(level,6*30+14,37);    
    setField(level,6*30+15,38);    
    setField(level,6*30+16,39);    
    setField(level,6*30+17,38);

    set_player(&level->player,5,6,1,100);  
}

static void getLevel78(Level* level)
{
    gint i,j;
    
    level->level=L78;

	level->max=10; 
    set_map(&level->map,29,11);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<4;i++){
    	for(j=0;j<11;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=4;i<25;i++){
		for(j=0;j<4;j++) setField(level,j*29+i,2);
		for(j=7;j<11;j++) setField(level,j*29+i,2);
	}
    setField(level,5*29+7,44);
	setField(level,5*29+9,44);	

    for(i=20;i<25;i++){
		setField(level,4*29+i,5);
		if(i%2)setField(level,5*29+i,44);
		setField(level,6*29+i,5);
	}

	setField(level,5*29+12,37);    
    setField(level,5*29+13,38);    
    setField(level,5*29+14,37);    
    setField(level,5*29+15,38);    
    setField(level,5*29+16,39);    
    setField(level,5*29+17,38);

    set_player(&level->player,5,5,15,15);  
}

static void getLevel79(Level* level)
{
    gint i,j;
    
    level->level=L79;

	level->max=21; 
    set_map(&level->map,41,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<2;i++){
    	for(j=1;j<19;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
        for(j=2;j<18;j++){
			alloc_balaban(i+2,j,4,&level->balabans);
		}
	}
    for(i=0;i<20;i++){
    	setField(level,i*41+i*2,45);
  		setField(level,i*41+i*2+1,45);	
		setField(level,i*41+i*2+2,45);	
    	setField(level,(19-i)*41+i*2,45);
  		setField(level,(19-i)*41+i*2+1,45);
  		setField(level,(19-i)*41+i*2+2,45);
  		setField(level,i*41+20,45);
	}
    for(i=4;i<37;i++){
    	setField(level,9*41+i,45);
    	setField(level,10*41+i,45);
	}

    set_player(&level->player,7,2,100,100);  
}

static void getLevel80(Level* level)
{
    gint i,j;
    
    level->level=L80;

	level->max=27; 
    set_map(&level->map,40,30);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=1;i<11;i++){
    	for(j=10;j<20;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=1;i<6;i++){
    	for(j=1;j<6;j++){
    		setField(level,i*40+j,45);
		}
    	for(j=34;j<39;j++){
    		setField(level,i*40+j,45);
		}
	}
    for(i=24;i<29;i++){
    	for(j=1;j<6;j++){
    		setField(level,i*40+j,45);
		}
    	for(j=34;j<39;j++){
    		setField(level,i*40+j,45);
		}
	}
    setField(level,4*40+7,44);
    setField(level,4*40+8,44);
    setField(level,4*40+9,44);
    setField(level,4*40+10,44);

    set_player(&level->player,6,4,100,100);  
}

static void getLevel81(Level* level)
{
    gint i,j;
    
    level->level=L81;

	level->max=25; 
    set_map(&level->map,40,20);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<4;i++){
    	for(j=0;j<20;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=4;i<20;i++){
  		setField(level,i*40+4,2);
	}
    for(i=6;i<13;i++){
  		setField(level,0*40+i,5);
  		setField(level,1*40+i,44);
  		setField(level,2*40+i,3);
  		setField(level,3*40+i,5);
	}

    set_player(&level->player,5,3,0,0);  
}

static gboolean level82_end(Level* level)
{
	if(level->map.field[6*33+9]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel82(Level* level)
{
    gint i,j;
    
    level->level=L82;

	level->max=13; 
    set_map(&level->map,33,20);
    level->endFunc=level82_end;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=0;j<20;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=14;i<20;i++){
   		setField(level,i*33+6,1);
	}
	setField(level,14*33+7,1);
    for(i=4;i<15;i++){
   		setField(level,i*33+8,1);
	}
    for(i=9;i<28;i++){
   		setField(level,4*33+i,1);
   		setField(level,14*33+i,1);
	}
    for(i=4;i<14;i++){
   		setField(level,i*33+6,45);
   		setField(level,i*33+7,45);
	}
    for(i=6;i<13;i+=3){
    	for(j=9;j<28;j+=3){
    		setField(level,i*33+j,20);
		 	setParx(level,i*33+j,6);
		}
	}

    set_player(&level->player,14,3,15,35);  
}

static void getLevel83(Level* level)
{
    gint i,j;
    
    level->level=L83;

	level->max=50; 
    set_map(&level->map,40,26);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=21;i<40;i++){
    	for(j=0;j<7;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}
    for(i=2;i<38;i++){
  		if(i!=7) setField(level,7*40+i,2);
  		if(i!=20) setField(level,12*40+i,2);
  		if(i!=17) setField(level,17*40+i,2);
	}
	setField(level,8*40+8,46);
	setField(level,13*40+21,46);
	setField(level,18*40+16,46); 
    set_player(&level->player,18,5,200,200);  
}

static gboolean level84_end(Level* level)
{
	if(level->map.field[6*38+36]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel84(Level* level)
{
    gint i,j;
    
    level->level=L84;

	level->max=21; 
    set_map(&level->map,38,8);
    level->endFunc=level84_end;

    level->balabans=NULL;
    for(i=0;i<6;i++){
    	for(j=0;j<5;j++){
			alloc_balaban(i,j,4,&level->balabans);
			alloc_balaban(i+32,j,4,&level->balabans);
		}
	}
    for(i=6;i<32;i++){
    	for(j=0;j<5;j++){
  			setField(level,j*38+i,1);
  		}
	}
    for(i=1;i<38;i++){
		setField(level,j*38+i,(i<35)?2:1);
	}
    setField(level,6*38+36,20);
	setParx(level,6*38+36,8);

	setField(level,7*38+6,44);

	setField(level,4*38+16,37);    
    setField(level,4*38+17,38);    
    setField(level,4*38+18,37);    
    setField(level,4*38+19,38);    
    setField(level,4*38+20,39);    
    setField(level,4*38+21,38);

    set_player(&level->player,9,6,200,200);  
}

static void getLevel85(Level* level)
{
    gint i,j;
    
    level->level=L85;

	level->max=22; 
    set_map(&level->map,32,16);
    level->endFunc=NOT_END;

    level->balabans=NULL;
    for(i=0;i<5;i++){
    	for(j=3;j<13;j++){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

	setField(level,0*32+10,23);
	setField(level,1*32+10,9);
 	setParx(level,0*32+10,10);
 	setPary(level,0*32+10,1);

	setField(level,15*32+22,21);
	setField(level,14*32+22,7);
 	setParx(level,15*32+22,22);
 	setPary(level,15*32+22,14);

    setField(level,0*32+31,17);
    setParx(level,0*32+31,0);
    setPary(level,0*32+31,0);
    setField(level,0*32+0,18);
    setParx(level,0*32+0,1);

    setField(level,15*32+0,17);
    setParx(level,15*32+0,31);
    setPary(level,15*32+0,15);
    setField(level,15*32+31,18);
    setParx(level,15*32+31,2);


    set_player(&level->player,6,3,8,8);  
}

static void getLevel86(Level* level)
{
    gint i,j;
    
    level->level=L86;

	level->max=11; 
    set_map(&level->map,45,26);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
    for(i=0;i<21;i+=5){
    	for(j=0;j<26;j+=5){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

    set_player(&level->player,22,12,5,30);  
}

static gboolean level87_end(Level* level)
{
	if(level->map.field[1*45+1]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel87(Level* level)
{
    gint i,j;
    
    level->level=L87;

	level->max=11; 
    set_map(&level->map,45,26);
    level->endFunc=level87_end;

    level->balabans=NULL;
    for(i=0;i<21;i+=5){
    	for(j=0;j<26;j+=5){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

    for(i=1;i<45;i+=3){
    	for(j=1;j<26;j+=3){
			setField(level,j*45+i,20);
    		setParx(level,j*45+i,14);
		}
	}

    set_player(&level->player,22,12,2,33);  
}

static gboolean level88_end(Level* level)
{
	if(level->map.field[1*45+32]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel88(Level* level)
{
    gint i,j;
    
    level->level=L88;

	level->max=10; 
    set_map(&level->map,45,26);
    level->endFunc=level88_end;

    level->balabans=NULL;
    for(i=0;i<20;i+=4){
    	for(j=0;j<26;j+=5){
			alloc_balaban(i,j,4,&level->balabans);
		}
	}

    for(i=32;i<45;i+=3){
    	for(j=1;j<26;j+=3){
			setField(level,j*45+i,20);
    		setParx(level,j*45+i,10);
		}
	}

    set_player(&level->player,22,12,100,100);  
}

static gboolean level89_end(Level* level)
{
	if(level->map.field[1*45+32]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel89(Level* level)
{
    gint i,j;
    
    level->level=L89;

	level->max=16; 
    set_map(&level->map,45,26);
    level->endFunc=level89_end;

    level->balabans=NULL;
    for(i=0;i<20;i+=3){
    	for(j=0;j<26;j+=5){
			alloc_balaban(i,j,j<13?1:4,&level->balabans);
		}
	}

    for(i=32;i<45;i+=3){
    	for(j=1;j<26;j+=3){
			setField(level,j*45+i,20);
    		setParx(level,j*45+i,16);
		}
	}

    set_player(&level->player,22,12,25,10);  
}

static void getLevel90(Level* level)
{
    gint i,j;
    
    level->level=L90;

	level->max=14; 
    set_map(&level->map,33,16);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<16;j++){
    	for(i=0;i<2;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
		alloc_balaban(2,j,0,&level->balabans);
	}
   for(i=10;i<26;i+=5){
    	for(j=(i/5)%4;j<16;j+=4){
			setField(level,j*33+i,1);
		}
	}
    set_player(&level->player,13,7,100,0);  
}

static void getLevel91(Level* level)
{
    gint i,j;
    
    level->level=L91;

	level->max=12; 
    set_map(&level->map,27,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<9;j++){
    	for(i=0;i<2;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	alloc_balaban(0,23,0,&level->balabans);
    set_player(&level->player,0,24,100,0);  
}

static void getLevel92(Level* level)
{
    gint i,j;
    
    level->level=L92;

	level->max=19; 
    set_map(&level->map,31,29);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<13;j++){
    	for(i=0;i<2;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	alloc_balaban(1,25,0,&level->balabans);
	setField(level,22*31+0,44);
    set_player(&level->player,1,26,100,0);  
}

static void getLevel93(Level* level)
{
    gint i,j;
    
    level->level=L93;

	level->max=13; 
    set_map(&level->map,23,21);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<11;j++){
    	for(i=0;i<3;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	alloc_balaban(2,19,0,&level->balabans);
	setField(level,19*23+1,44);
	setField(level,19*23+8,44);
	setField(level,19*23+16,44);
    set_player(&level->player,2,20,100,0);  
}

static void getLevel94(Level* level)
{
    gint i,j;
    
    level->level=L94;

	level->max=16; 
    set_map(&level->map,26,21);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<11;j++){
    	for(i=0;i<4;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	alloc_balaban(3,19,0,&level->balabans);
	setField(level,19*26+2,44);
	setField(level,19*26+9,44);
	setField(level,19*26+18,44);
	setField(level,19*26+21,44);
	setField(level,19*26+24,44);

    set_player(&level->player,0,20,100,0);  
}

static void getLevel95(Level* level)
{
    gint i,j;
    
    level->level=L95;

	level->max=22; 
    set_map(&level->map,31,21);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(j=0;j<11;j++){
    	for(i=0;i<3;i++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	alloc_balaban(2,19,0,&level->balabans);
	setField(level,19*31+29,46);
	setField(level,19*31+1,46);
    set_player(&level->player,2,20,100,0);  
}

static gboolean level96_end(Level* level)
{
	if(level->map.field[6*36+1]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel96(Level* level)
{
    gint i,j;
    
    level->level=L96;

	level->max=39; 
    set_map(&level->map,47,12);
    level->endFunc=level96_end;

    level->balabans=NULL;
	for(i=0;i<8;i++){
    	for(j=0;j<4;j++){
    		alloc_balaban(i,j,4,&level->balabans);
    		alloc_balaban(i,8+j,4,&level->balabans);
		}
	}
	for(i=39;i<47;i++){
    	for(j=0;j<4;j++){
    		alloc_balaban(i,j,4,&level->balabans);
    		alloc_balaban(i,8+j,4,&level->balabans);
		}
	}
	for(i=8;i<39;i++){
    	for(j=0;j<4;j++){
			setField(level,j*47+i,1);
			setField(level,(j+8)*47+i,1);
		}
	}

	setField(level,3*47+21,37);    
    setField(level,3*47+22,38);    
    setField(level,3*47+23,37);    
    setField(level,3*47+24,38);    
    setField(level,3*47+25,39);    
    setField(level,3*47+26,38);

	setField(level,8*47+21,37);    
    setField(level,8*47+22,38);    
    setField(level,8*47+23,37);    
    setField(level,8*47+24,38);    
    setField(level,8*47+25,39);    
    setField(level,8*47+26,38);

	for(i=1;i<46;i++) setField(level,4*47+i,(i%2)==0?6:1); 
	for(i=0;i<47;i++) setField(level,7*47+i,((i%2)==0 && i>3 && i<44)?6:1);   

    setField(level,6*47+1,20);
	setParx(level,6*47+1,20);
    setField(level,6*47+45,20);
	setParx(level,6*47+45,20);
    setField(level,5*47+14,44);
    setField(level,5*47+24,44);

    set_player(&level->player,14,6,200,200);  
}

static gboolean level97_end(Level* level)
{
	if(level->map.field[6*36+1]==0 ) return COUNT_END(level);
    return TRUE;
}

static void getLevel97(Level* level)
{
    gint i,j;
    
    level->level=L97;

	level->max=34; 
    set_map(&level->map,47,12);
    level->endFunc=level97_end;

    level->balabans=NULL;
	for(i=0;i<8;i++){
    	for(j=0;j<4;j++){
    		alloc_balaban(i,j,4,&level->balabans);
    		alloc_balaban(i,8+j,1,&level->balabans);
		}
	}
	for(i=39;i<47;i++){
    	for(j=0;j<4;j++){
    		alloc_balaban(i,j,1,&level->balabans);
    		alloc_balaban(i,8+j,4,&level->balabans);
		}
	}
	for(i=8;i<39;i++){
    	for(j=0;j<4;j++){
			setField(level,j*47+i,1);
			setField(level,(j+8)*47+i,1);
		}
	}

	setField(level,3*47+21,37);    
    setField(level,3*47+22,38);    
    setField(level,3*47+23,37);    
    setField(level,3*47+24,38);    
    setField(level,3*47+25,39);    
    setField(level,3*47+26,38);

	setField(level,8*47+21,37);    
    setField(level,8*47+22,38);    
    setField(level,8*47+23,37);    
    setField(level,8*47+24,38);    
    setField(level,8*47+25,39);    
    setField(level,8*47+26,38);

	for(i=1;i<46;i++) setField(level,4*47+i,(i%2)==0?6:1); 
	for(i=0;i<47;i++) setField(level,7*47+i,((i%2)==0 && i>3 && i<44)?6:1);   

    setField(level,6*47+1,20);
	setParx(level,6*47+1,18);
    setField(level,6*47+45,20);
	setParx(level,6*47+45,18);

    set_player(&level->player,14,6,200,200);  
}

static void getLevel98(Level* level)
{
    gint i,j;
    
    level->level=L98;

	level->max=21; 
    set_map(&level->map,33,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(i=0;i<6;i++){
    	for(j=0;j<8;j++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}
	for(i=6;i<26;i++) setField(level,8*33+i,2);
	for(i=7;i<25;i++) setField(level,12*33+i,2);
	for(i=8;i<24;i++) setField(level,16*33+i,2);

	for(i=9;i<12;i++) setField(level,i*33+22,25);
	for(i=13;i<16;i++) setField(level,i*33+22,25);

    set_player(&level->player,13,17,50,50);  
}

static void getLevel99(Level* level)
{
    gint i,j;
    
    level->level=L99;

	level->max=36; 
    set_map(&level->map,35,25);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(i=0;i<4;i++){
    	for(j=5;j<19;j++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}

	setField(level,3*35+4,2);
	setField(level,4*35+3,2);
	setField(level,4*35+4,2);
	setField(level,3*35+3,17);
    setParx(level,3*35+3,34);
    setPary(level,3*35+3,24);
    setField(level,24*35+34,18);
    setParx(level,24*35+34,1);

	setField(level,3*35+30,2);
	setField(level,4*35+31,2);
	setField(level,4*35+30,2);
	setField(level,3*35+31,17);
    setParx(level,3*35+31,0);
    setPary(level,3*35+31,24);
    setField(level,24*35+0,18);
    setParx(level,24*35+0,2);

	setField(level,20*35+4,2);
	setField(level,19*35+3,2);
	setField(level,19*35+4,2);
	setField(level,20*35+3,17);
    setParx(level,20*35+3,34);
    setPary(level,20*35+3,0);
    setField(level,0*35+34,18);
    setParx(level,0*35+34,3);

	setField(level,20*35+30,2);
	setField(level,19*35+31,2);
	setField(level,19*35+30,2);
	setField(level,20*35+31,17);
    setParx(level,20*35+31,0);
    setPary(level,20*35+31,0);
    setField(level,0*35+0,18);
    setParx(level,0*35+0,4);

    set_player(&level->player,33,19,100,100);  
}

static void getLevel100(Level* level)
{
    gint i,j;
    
    level->level=L100;

	level->max=26; 
    set_map(&level->map,39,21);
    level->endFunc=COUNT_END;

    level->balabans=NULL;
	for(i=0;i<8;i++){
    	for(j=0;j<8;j++){
    		alloc_balaban(i,j,3,&level->balabans);
		}
	}

	for(i=11;i<36;i+=8){
    	for(j=1;j<20;j++){
    		if(j%2==1)setField(level,j*39+i,43);
            else if(j%4==2){setField(level,j*39+i,2);}
		}
	}

    for(i=15;i<32;i+=8){
    	for(j=3;j<18;j++){
    		if(j%2==1)setField(level,j*39+i,43);
            else if(j%4==0){setField(level,j*39+i,2);}
		}
	}

    set_player(&level->player,12,2,100,100);  
}


void getLevels2(Level* level,gint iLevel)
{
    switch(iLevel){
        case L1:
            getLevel1(level);
            break;
        case L2:
            getLevel2(level);
            break;
        case L3:
            getLevel3(level);
            break;
		case L4:
            getLevel4(level);
            break;
		case L5:
            getLevel5(level);
            break;
		case L6:
            getLevel6(level);
            break;
		case L7:
            getLevel7(level);
            break;
		case L8:
            getLevel8(level);
            break;
		case L9:
            getLevel9(level);
            break;
		case L10:
            getLevel10(level);
            break;
		case L11:
            getLevel11(level);
            break;
		case L12:
            getLevel12(level);
            break;
		case L13:
            getLevel13(level);
            break;
		case L14:
            getLevel14(level);
            break;
		case L15:
            getLevel15(level);
            break;
		case L16:
            getLevel16(level);
            break;
		case L17:
            getLevel17(level);
            break;
		case L18:
            getLevel18(level);
            break;
		case L19:
            getLevel19(level);
			break;
		case L20:
            getLevel20(level);
            break;
		case L21:
            getLevel21(level);
            break;
		case L22:
            getLevel22(level);
            break;
		case L23:
            getLevel23(level);
            break;
		case L24:
            getLevel24(level);
            break;
		case L25:
            getLevel25(level);
            break;
		case L26:
            getLevel26(level);
            break;
		case L27:
            getLevel27(level);
            break;
		case L28:
            getLevel28(level);
            break;
		case L29:
            getLevel29(level);
            break;
		case L30:
            getLevel30(level);
            break;
		case L31:
            getLevel31(level);
            break;
		case L32:
            getLevel32(level);
            break;
		case L33:
            getLevel33(level);
            break;
		case L34:
            getLevel34(level);
            break;
		case L35:
            getLevel35(level);
            break;
		case L36:
            getLevel36(level);
            break;
		case L37:
            getLevel37(level);
            break;
		case L38:
            getLevel38(level);
            break;
		case L39:
            getLevel39(level);
            break;
		case L40:
            getLevel40(level);
            break;
		case L41:
            getLevel41(level);
            break;
		case L42:
            getLevel42(level);
            break;
		case L43:
            getLevel43(level);
            break;
		case L44:
            getLevel44(level);
            break;
		case L45:
            getLevel45(level);
            break;
		case L46:
            getLevel46(level);
            break;
		case L47:
            getLevel47(level);
            break;
		case L48:
            getLevel48(level);
            break;
		case L49:
            getLevel49(level);
            break;
		case L50:
            getLevel50(level);
            break;
        case L51:
            getLevel51(level);
            break;
        case L52:
            getLevel52(level);
            break;
        case L53:
            getLevel53(level);
            break;
        case L54:
            getLevel54(level);
            break;
       case L55:
            getLevel55(level);
            break;
       case L56:
            getLevel56(level);
            break;
       case L57:
            getLevel57(level);
            break;
       case L58:
            getLevel58(level);
            break;
       case L59:
            getLevel59(level);
            break;
       case L60:
            getLevel60(level);
            break;
       case L61:
            getLevel61(level);
            break;
       case L62:
            getLevel62(level);
            break;
       case L63:
            getLevel63(level);
            break;
       case L64:
            getLevel64(level);
            break;
       case L65:
            getLevel65(level);
            break;
       case L66:
            getLevel66(level);
            break;
       case L67:
            getLevel67(level);
            break;
       case L68:
            getLevel68(level);
            break;
       case L69:
            getLevel69(level);
            break;
       case L70:
            getLevel70(level);
            break;
       case L71:
            getLevel71(level);
            break;
       case L72:
            getLevel72(level);
            break;
       case L73:
            getLevel73(level);
            break;
       case L74:
            getLevel74(level);
            break;
       case L75:
            getLevel75(level);
            break;
       case L76:
            getLevel76(level);
            break;
       case L77:
            getLevel77(level);
            break;
       case L78:
            getLevel78(level);
            break;
       case L79:
            getLevel79(level);
            break;
       case L80:
            getLevel80(level);
            break;
       case L81:
            getLevel81(level);
            break;
       case L82:
            getLevel82(level);
            break;
       case L83:
            getLevel83(level);
            break;
       case L84:
            getLevel84(level);
            break;
       case L85:
            getLevel85(level);
            break;
       case L86:
            getLevel86(level);
            break;
       case L87:
            getLevel87(level);
            break;
       case L88:
            getLevel88(level);
            break;
       case L89:
            getLevel89(level);
            break;
       case L90:
            getLevel90(level);
            break;
       case L91:
            getLevel91(level);
            break;
       case L92:
            getLevel92(level);
            break;
       case L93:
            getLevel93(level);
            break;
       case L94:
            getLevel94(level);
            break;
       case L95:
            getLevel95(level);
            break;
       case L96:
            getLevel96(level);
            break;
       case L97:
            getLevel97(level);
            break;
       case L98:
            getLevel98(level);
            break;
       case L99:
            getLevel99(level);
            break;
       case L100:
            getLevel100(level);
            break;
       default:
            getLevel1(level);
            break;
    }
} 

