/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */
#include "level3.h"
#include "level_func.h"

#define L1 1

static gboolean level1_end(Level* level)
{
    if(level->map.field[6*16]==6 && level->player.projectiles<1) return FALSE;
    return TRUE;
}

static void getLevel1(Level* level)
{
    gint i;

    level->level=L1;

    level->max=15; 
    set_map(&level->map,25,12);
    level->endFunc=level1_end;
    
    for(i=0;i<12;i++){
		if(i==5)i++;
        setField(level,i*25,3);
		setField(level,i*25+1,2);
    }
  
    setField(level,25*5+2,46);

    level->balabans=NULL;
    for(i=0;i<12;i++){
		alloc_balaban(24,i,1,&level->balabans);
		alloc_balaban(23,i,2,&level->balabans);
	}
    
	setField(level,5*25+10,37);    
    setField(level,6*25+11,38);    
    setField(level,5*25+12,37);    
    setField(level,6*25+13,38);    
    setField(level,5*25+14,39);    
    setField(level,6*25+15,38);
         
    set_player(&level->player,22,6,5,5);  
}

void getLevels3(Level* level,gint iLevel)
{
    switch(iLevel){
        case L1:
            getLevel1(level);
            break;
       default:
            getLevel1(level);
            break;
    }
}    
